#include "EngineSelectionDialog.h"
#include <qlabel.h>
#include <qlistbox.h>
#include <qtextview.h>
#include <qlayout.h>
#include <qdir.h>
#include <qpalette.h>
#include <qpe/qpeapplication.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qtextstream.h>




EngineSelectionDialog::EngineSelectionDialog(QWidget *parent, const char *name):QWidget(parent,0)
{
//    setCaption(caption);
	qDebug("EngineSelectionDialog constructor");
    if ( parent )
    {
        setPalette(parent->palette());
    }

  //  setMinimumSize(190,240);

    QVBoxLayout *vbox = new QVBoxLayout( this, 6, 6 );
    QLabel *label=new QLabel("Select chess engine:",this);
    vbox->addWidget(label);
    list=new QListBox(this);
    view=new QTextView(this);
    vbox->addWidget(list,5);
    vbox->addWidget(view,10); 


// scan for available engines

    QDir    cl(QPEApplication::qpeDir()+"/chess/engines");
      
    if ( cl.exists() )
    {
    qDebug("Directory exists");
        cl.setFilter( QDir::Dirs);
        const QFileInfoList *lst=cl.entryInfoList();        
        QFileInfoListIterator it( *lst );
        QFileInfo *fi; 
        QString fName;
        unsigned int i=1;
        while ( (fi=it.current()) ) 
        { 
            fName=fi->fileName();
            if(fName!="." && fName!=".." && QFile::exists(fi->absFilePath()+"/description"))
            {
                list->insertItem(fName);
                i++;
            }
            ++it;            
        }
    }

    connect(list,SIGNAL(highlighted(int)),this, SLOT(listHighlighted( int)));

    list->setFocus();
}

EngineSelectionDialog::~EngineSelectionDialog()
{

}

QString EngineSelectionDialog::currentEngine()
{
QString tmp = list->currentText();
return tmp;
}

void EngineSelectionDialog::listHighlighted( int index )
{
    QString engine=list->text(index);

    QFile   f(QPEApplication::qpeDir()+"/chess/engines/"+engine+"/description");

    if ( f.exists() && f.open(IO_ReadOnly) )
    {
        QTextStream t( &f ); 
        view->setText(t.read());
        f.close();
    }
}
