#include "ThemeBoardSelectionDialog.h"
#include <qlabel.h>
#include <qlistbox.h>
#include <qtextview.h>
#include <qlayout.h>
#include <qdir.h>
#include <qobject.h>
#include <qpalette.h>
#include <qpe/qpeapplication.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qtextstream.h>

#include <kdebug.h>


ThemeBoardSelectionDialog::ThemeBoardSelectionDialog(QWidget *parent, const char *name):QWidget(parent,0)
{
//    setCaption(caption);
	qDebug("ThemeBoardSelectionDialog constructor");
    if ( parent )
    {
        setPalette(parent->palette());
    }

  //  setMinimumSize(190,240);

    QVBoxLayout *vbox = new QVBoxLayout( this, 3, 6 );
    QLabel *label=new QLabel("Select theme:",this);
    QLabel *label2=new QLabel("Visit www.houseoffish.org/knights for\nadditional themes",this);
    vbox->addWidget(label);
    list=new QListBox(this);
    view=new QTextView(this);
    view->setMinimumHeight(70);
    vbox->addWidget(list,5);
    vbox->addWidget(view,5); 
    vbox->addWidget(label2);

// scan for available Themes

    QDir    cl(QPEApplication::qpeDir()+"pics/knights/themes/");
    kdDebug() << cl.absPath() << endl;
      
    if ( cl.exists() )
    {
    qDebug("Directory exists");
    
        cl.setFilter( QDir::Dirs);
        cl.setNameFilter("KB*");
        const QFileInfoList *lst=cl.entryInfoList();        
        QFileInfoListIterator it( *lst );
        QFileInfo *fi; 
        QString fName; 
        unsigned int i=1;
        while ( (fi=it.current()) ) 
        { 
            fName=fi->fileName();
             if(fName!="." && fName!=".." && QFile::exists(fi->absFilePath()))
             //if(fName!="." && fName!="..")
             {
                list->insertItem(QString(fName).mid(2));
                i++;
             }
            ++it;            
        }
    }

    connect(list,SIGNAL(highlighted(int)),this, SLOT(listHighlighted( int)));

    list->setFocus();
}

ThemeBoardSelectionDialog::~ThemeBoardSelectionDialog()
{

}

QString ThemeBoardSelectionDialog::currentBoardTheme()
{
QString tmp = "KB" + list->currentText();
return tmp; 
}

void ThemeBoardSelectionDialog::listHighlighted( int index )
{
    QString Theme=list->text(index);

    QFile   f(QPEApplication::qpeDir()+"/pics/knights/themes/KB"+Theme+"/description");

    if ( f.exists() && f.open(IO_ReadOnly) )
    {
        QTextStream t( &f ); 
        view->setText(t.read());
        f.close();
    }
}
