/***************************************************************************
                          core.h  -  description
                             -------------------
    begin                : Tue Oct 2 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CORE_H
#define CORE_H

#include <qwidget.h>
#include <qtimer.h>
#include <qlist.h>
#include "definitions.h"
#include "resource.h"
#include "match.h"
#include "engineio.h"
//#include "internetio.h"
#include "thinbuttons.h"
#include "list_pgn.h"

#include <qpe/applnk.h>

/**
  *@author Troy Corbin Jr.
  */

class core : public QWidget
{
   Q_OBJECT
	public:
																core(QWidget *parent=0, const char *name=0, resource *Rsrc=0);
																~core();
		QStringList*								notation( void );
		QString											caption( void );
		bool												modified( void );
		bool												paused( void );
		bool												isOnline( void );
		bool												flag( const bool );
		char												onMove( void );
		char												whiteInput( void );
		char												blackInput( void );
		void												swapInput( void );
		void												removeServer( void );
                bool												engineHints;
                bool												engineUndos;

	public slots:
		void												CoreLoop( void );
		void												addMatch( int );
		void												addOnlineMatch( const char );
//		netconcomm*									addServer( void );
		bool												clearMatch( void );
		bool												clearAll( void );
		void												setMatch( int, const bool );
		void												setMatch( int );
		void												relayMove( const ChessMove, const int );
		void												relayCMD( const int, const int, const QString &val = QString::null );
		void												resetServer( void );
		void												matchMenu( int );
		void												resize( void );
		bool												save( const bool, const bool );
                bool												dosave(const bool);
                void												loadFromDialog();
		bool												load( void );
                void												load(const DocLnk&);
		//bool												load( const QString );
		bool												load( const int );
                
		void												slot_setNotation( void );
		void												slot_setClocks( void );
		void												slot_setStatusBar( const int, const QString& );
		void												review( int );
		void												setModified( const bool );
		void												submitMessage( const QString& );
		void												serverSelfDestruct( void );
		QString											clock( const bool );

	signals:
		void												requestResize( void );
		void												setStatusBar( const int ID, const QString& MSG=QString::null );
		void												setNotation( void );
		void												setClocks( void );
		void												initMatch( void );
		void												serverDestroyed( void );
		void												enableDifficultyMenu(bool);
	protected:
		bool												findMatch( const int );
		void												initEngines( bool revisit=FALSE );
		void												sendCMD( const int, const int, const QString& value = QString::null);

	protected slots:
		void												listDestroyed( void );

	private:
		resource										*Resource;
		QTimer											CoreClock;
		thinbuttons									*ButtonGroup;
                QDialog *listPGNDialog;
                QDialog *fileSelectorDialog;
		list_pgn										*listPGN;
		QList<engineio>							L_Engine;
		//QList<internetio>						L_Server;
		QList<match>								L_Match;
		int													ID_Current;
		int													ID_Last_ICS_Match;
};

#endif
