/***************************************************************************
                          dlg_login.cpp  -  description
                             -------------------
    begin                : Sat Sep 29 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlg_login.h"

dlg_login::dlg_login(QWidget *parent, const char *name, resource *Rsrc, serverList::Iterator ITin ) :
	KDialogBase(	parent,
								name,
								TRUE,
								i18n("Login Prompt"),
								Help|Ok,
								Ok,
								TRUE )
{
	Resource = Rsrc;
	IT = ITin;
	BOX_Parent = makeHBoxMainWidget();

	BOX_TEXT = new QVBox( BOX_Parent );
	TEXT_Login = new QLabel( BOX_TEXT );
	TEXT_Password = new QLabel( BOX_TEXT );

	TEXT_Login->setText( i18n("Login:") );
	TEXT_Password->setText( i18n("Password:") );

	BOX_EDIT = new QVBox( BOX_Parent );
	EDIT_Login = new KLineEdit( BOX_EDIT );
	EDIT_Password = new KLineEdit( BOX_EDIT );

	EDIT_Password->setEchoMode( QLineEdit::Password );
	EDIT_Login->setText( (*IT).UserName );
	EDIT_Password->setText( (*IT).Password );

	/* Init the buttons */
	showButtonCancel( TRUE );
	showButtonOK( TRUE );
	showButton( Help, TRUE );

	enableButtonCancel( TRUE );
	enableButtonOK( TRUE );
	enableButton( Help, TRUE );
	setButtonOKText( i18n("Login"), i18n("Log in to the chess server using this name and password.") );
	setHelp("prefs");
	show();
}
///////////////////////////////////////
//
//	dlg_login::~dlg_login
//
///////////////////////////////////////
dlg_login::~dlg_login()
{
	delete EDIT_Password;
	delete EDIT_Login;
	delete BOX_EDIT;
	delete TEXT_Password;
	delete TEXT_Login;
	delete BOX_TEXT;
}
///////////////////////////////////////
//
//	dlg_login::slotOk
//
///////////////////////////////////////
void dlg_login::slotOk( void )
{
	(*IT).UserName = EDIT_Login->text();
	(*IT).Password = EDIT_Password->text();
        close();
	//slotDelayedDestruct();
}

