/***************************************************************************
                          engineio.h  -  description
                             -------------------
    begin                : Sat Jun 30 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ENGINEIO_H
#define ENGINEIO_H

#include <kprocess.h>
#include <qstring.h>
#include <qvaluelist.h>
#include <qfile.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "definitions.h"
#include "resource.h"

#define STRING_MAX 255
/**
  *@author Troy Corbin Jr.
  */

class engineio : public QObject
{
  Q_OBJECT
	public:

		/* XBoard protover 2 */
		bool									FEATURE_Analyze;
		bool									FEATURE_Colors;
		bool									FEATURE_Draw;
		bool									FEATURE_ICS;
		bool									FEATURE_Name;
		bool									FEATURE_Pause;
		bool									FEATURE_Ping;
		bool									FEATURE_PlayOther;
		bool									FEATURE_Reuse;
		bool									FEATURE_SetBoard;
		bool									FEATURE_SAN;
		bool									FEATURE_SIGINT;
		bool									FEATURE_SIGTERM;
		bool									FEATURE_Time;
		bool									FEATURE_UserMove;
		int										FEATURE_Variants;
		char									FEATURE_MyName[STRING_MAX];
                bool									FEATURE_Hint;
                bool									FEATURE_Undo;
		/* XBoard protover 3 */
		int										FEATURE_Level;
		int										FEATURE_BookEngine;

		bool									Check;
		bool									Turn;
		bool									BookEngine;
		bool									Team;
		bool									Army;
		int										InitTimer;
		QString								Inbound;
		ChessMove							Move;
                bool nolevels;
                

													engineio( resource *Rsrc=0 );
													~engineio();

		int										matchID( void );
		void									setMatchID( const int ID );
		void									Start( const int ID );
		int										Poll( void );
		void									SendCMD( const int CMD, const int Value=0 );
		void									SendCMD( const int CMD, const QString Value );

	public slots:
		void									SendClear( KProcess* );
		void									Recv( KProcess*, char*, int );

	protected:
		void									Send( void );
		void									Kill( void );
		void									ReadFIFO( void );
		void									WriteFIFO( void );
		void									WriteFIFO( const char *Data );
		void									WriteFIFO( const QString Data );
		void									ClearMove( void );

	private:

		resource							*Resource;
		engineList::Iterator	IT;

		/* States */
		bool									SafeToSend;
		bool									SendSIGINT;
		bool									CleanBuffer;
		bool									DelayedGo;
		bool									Forced;
		bool									AcceptIllegal;
	signals:
        	void									enableDifficultyMenu(bool);
		/* References */
		int										MatchID;
		QFile									*Log;
		int										Protocol;

		/* Data */
		KProcess							*engine;
		QString								FIFO_In;
		QString								FIFO_Out;
		QString								FIFO_Tmp;
		QString								FIFO_Token;
};

#endif
