/***************************************************************************
                          internetio.h  -  description
                             -------------------
    begin                : Thu Aug 16 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INTERNETIO_H
#define INTERNETIO_H

#include "qprocess.h"
/* QT */
#include <qobject.h>
#include <qsocket.h>
#include <qdns.h>
#include <qlist.h>
/* Local */
#include "definitions.h"
#include "resource.h"
#include "netconcomm.h"
#include "dlg_login.h"
#include "dlg_challenge.h"

/**
  *@author Troy Corbin Jr.
  */

struct MatchRecord
{
	int					knightsID;
	int					serverID;
	bool				observing;
	bool				examining;
	bool				finished;
};

class internetio : public QObject
{
  Q_OBJECT
	public:
															/* These are used to communicate with Core */
		QString										Inbound;
		QString										Outbound;
		ICSPosition								Pos;
		int												extendedData;

															/* This is used to communicate directly with the console */
		netconcomm								*NetConComm;
		
															internetio(QWidget* parent=0, const char *name=0, resource *Rsrc=0 );
															~internetio();
		int												matchID( void );
		bool											matchID( const int );
		void											addMatchID( const int );
		void											removeMatchID( const int );
		int												Poll( void );
		void											sendCMD( const int CMD, const int KnightsMatch=-1 );
		
	public slots:
		void											Send( const QString& );
		void											slot_getAddress( void );
		void											slot_newMatch( const QString& );
		void											nullifyChallenge( void );
		void											acceptChallenge( void );
		void											declineChallenge( void );
		
	signals:
		void											newGame( const char Army );
		void											shutdown( void );

	protected:
		bool											readLine( void );
		bool											findICSMatchID( const int );
		void											findKnightsMatchID( const int );
		void											ParseData( void );
		void											ParseMovelist( void );
		bool											ParseStyle12( void );
		void											ParsePlayer( QString Handle );

	protected slots:
		void											finishInit( void );

	private:
	
		resource									*Resource;
		dlg_login									*LoginDlg;
		dlg_challenge							*Challenge;
		playerinfo								player;
		playerList								players;
		playerList::Iterator			playersIT;
		serverList::Iterator			serversIT;
		
		/* These are used for the connection & logon */
		QFile											*Log;
		QSocket										*Sock;
		QDns											*Dns;
		QProcess									*Timeseal;
		QString										Host;
		QString										Login;
		QString										Password;
		QString										TimesealFilename;
		Q_UINT16									Port;
		QList<MatchRecord>				L_Match;
		int												LoginStage;
		int												NewICSGameNumber;
		int												SeekTimer;
		int												LastType;
		int												prevMovesMatch;
};

#endif
