/***************************************************************************
                          knights.cpp  -  description
                             -------------------
    begin                : Thu Mar  1 10:43:51 CST 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "knights.h"
//#include "wiz_setup.h"
#include <qstyle.h>
//#include <kicontheme.h>
//#include <kkeydialog.h>
#include <qmessagebox.h>
#include <qpe/qpeapplication.h>
#include <qpe/applnk.h>
#include "aboutdialog.h"
Knights::Knights(QWidget *parent, const char *name, const QString &args="") : QMainWindow(parent, name)
{
setCaption("Knights");
	InitAll = TRUE;
	ResizeFlag = TRUE;
	Minimized = FALSE;
//	args = Args;
argsFileName=args;
//	SplashScreen = NULL;
	#ifdef CONSOLE
        console = NULL;
        #endif
}


void Knights::about()
{
aboutDialog *ab = new aboutDialog(this);
ab->show();


}

void Knights::enableDifficultyMenu(bool enable)
{
settingsMenu->setItemEnabled(MENU_DIFFICULTY,enable);
}

Knights::~Knights()
{
// Looks like in KDE3 the shutdown signal & class destructor are called properly.
// This wasn't the case in KDE2, that's why I had KillAll() here and as a slot
// for shutdown. So, unless I see a need to bring it back, I'm removing KillAll
// from the destructor.
//	KillAll();
}

void Knights::closeEvent ( QCloseEvent * e ) {
bool a =  Core->clearAll();
if (a)
  e->accept();
else
  e->ignore();
}


///////////////////////////////////////
//
//	Knights::BirthAll
//
///////////////////////////////////////
void Knights::BirthAll(void)
{
	SettingsBase	= NULL;
	Resource				= new resource();
/*	if( Resource->OPTION_Show_Splash )
		SplashScreen = new splash();*/
//	aboutData				= new KAboutData( "knights", I18N_NOOP("Knights"), VERSION );
	topMenu					= new QPEMenuBar(this);
	Accel						= new QAccel(this);
//	help						= helpMenu();
	fileMenu					= new QPopupMenu( this , "fileMenu");
	settingsMenu		= new QPopupMenu( this, "settingsMenu");
	newGames				= new QPopupMenu( this , "newGames");
	matchMenu				= new QPopupMenu( this, "matchMenu");
	drawMenu				= new QPopupMenu( this, "drawMenu");
        helpMenu			= new QPopupMenu(this,"helpMenu");
        difficultyMenu = new QPopupMenu(this,"difficultyMenu");
	tutorialMenu		= new QPopupMenu( this, "tutorialMenu");
	MainFrame				= new QFrame( this, "MainFrame" );
	Core						= new core( MainFrame, "Core", Resource );
	Message					= new QLabel( MainFrame, "Message");
	whiteTimeLabel	= new QLabel( MainFrame, "whiteTimeLabel");
	blackTimeLabel	= new QLabel( MainFrame, "blackTimeLabel");
	notationBar			= new KComboBox( MainFrame, "notationBar");
	
	/* Connect all Signals & Slots */
	connect( Core, SIGNAL( requestResize() ), this, SLOT( resizeMainFrame() ) );
	connect( Core, SIGNAL( setStatusBar(const int, const QString& ) ), this, SLOT( setStatusBar(const int, const QString& ) ) );
	connect( Core, SIGNAL( setNotation() ), this, SLOT( setNotation() ) );
	connect( Core, SIGNAL( initMatch() ), this, SLOT( initMatch() ) );
	connect( Core, SIGNAL( setClocks() ), this, SLOT( setClocks() ) );
	connect( Core, SIGNAL( serverDestroyed() ), this, SLOT( netConnect() ) );
        connect( Core, SIGNAL( enableDifficultyMenu(bool)),this,SLOT(enableDifficultyMenu(bool)));
	connect( notationBar, SIGNAL( activated(int) ), Core, SLOT( review(int) ) );
}
///////////////////////////////////////
//
//	Knights::queryClose
//
///////////////////////////////////////
bool Knights::queryClose(void)
{
	return Core->clearAll();
}
///////////////////////////////////////
//
//	Knights::KillAll
//
///////////////////////////////////////
void Knights::KillAll(void)
{
//Core->clearAll();
qDebug("Knights::KillAll 1");
//	Accel->writeSettings();
	
#ifdef CONSOLE
        if( console != NULL ) delete console;
     #endif
	delete newGames;
	delete fileMenu;
	delete matchMenu;
	delete drawMenu;
	delete tutorialMenu;
	delete settingsMenu;
	delete SettingsBase;
        delete whiteTimeLabel;
	delete blackTimeLabel;
	delete notationBar;
	delete Message;
//	delete aboutData;
	delete Core;
	delete MainFrame;
	delete Resource;
}
///////////////////////////////////////
//
//	Knights::Init
//
///////////////////////////////////////
bool Knights::Init( void )
{
qDebug("Knights::Init 1");
	
	//wiz_setup *Wizard;
	QColorGroup GroupWhite;
	QColorGroup GroupBlack;

	BirthAll();
	SelectTheme(-1,-1);
	Resource->setAudio();
	ResizeFlag = FALSE;
	/*
			Define accelerators
// 	*/
// 	Accel->insertItem( i18n("Previous Move"), "Previous Move", Key_Up, TRUE );
// 	Accel->insertItem( i18n("Next Move"), "Next Move", Key_Down, TRUE );
// 	Accel->insertItem( i18n("Enter Text"), "Enter Text", Key_Return, TRUE );
// 	Accel->insertItem( i18n("Page Up"), "Page Up", Key_PageUp, TRUE );
// 	Accel->insertItem( i18n("Page Down"), "Page Down", Key_PageDown, TRUE );
// 	Accel->insertItem( i18n("Increase Board Size"), "Board Up", ALT + Key_Plus, TRUE );
// 	Accel->insertItem( i18n("Decrease Board Size"), "Board Down", ALT + Key_Minus, TRUE );
// 	Accel->insertItem( i18n("Last History Item"), "Last History Item", SHIFT + Key_Up, TRUE );
// 	Accel->insertItem( i18n("Next History Item"), "Next History Item", SHIFT + Key_Down, TRUE );
// 	Accel->insertItem( i18n("Reply to the Last Tell"), "Tell Reply", ALT + Key_R, TRUE );
// 	Accel->insertItem( i18n("Reply to the Channel"), "Channel Reply", ALT + Key_C, TRUE );
// 	Accel->insertItem( i18n("Kibitz"), "Kibitz", ALT + Key_K, TRUE );
// 	Accel->insertItem( i18n("Whisper"), "Whisper", ALT + Key_W, TRUE );
// 	Accel->readSettings();
// 	Accel->connectItem( "Board Down" , this, SLOT( boardSmaller() ) );
// 	Accel->connectItem( "Board Up" , this, SLOT( boardBigger() ) );
// 	Accel->connectItem( "Previous Move" , this, SLOT( PrevNotation() ) );
// 	Accel->connectItem( "Next Move" , this, SLOT( NextNotation() ) );
	/*
			newGames menu

	*/


	// MENU_SOLITARE
	newGames->insertItem( i18n( "&Solitaire Chess" ), Core, SLOT(addMatch(int)), 0, MENU_SOLITARE );
	// MENU_VS_PC
	newGames->insertItem( i18n( "vs. Com&puter" ), Core, SLOT(addMatch(int)), 0, MENU_VS_PC );
	// MENU_VS_EMAIL
// 	newGames->insertItem( i18n( "vs. &Email" ), Core, SLOT(addMatch(int)), 0, MENU_VS_EMAIL );
// 	// MENU_PC_VS_PC
 	newGames->insertItem( i18n( "&Computer vs. Computer" ), Core, SLOT(addMatch(int)), 0, MENU_PC_VS_PC );

        /*
			matchMenu menu
	*/
	matchMenu->setCheckable(TRUE);
	// MENU_DRAW
	matchMenu->insertItem( i18n( "&Draw" ), drawMenu, MENU_DRAW );
	matchMenu->setItemEnabled( MENU_DRAW, FALSE );
	// MENU_RETRACT
	matchMenu->insertItem(i18n( "&Retract Move" ), Core, SLOT(matchMenu(int)), 0, MENU_RETRACT );
	matchMenu->setItemEnabled( MENU_RETRACT, FALSE );
	matchMenu->setWhatsThis( MENU_RETRACT, i18n( "Select this to retract your last move." ) );
	// MENU_RESIGN
	matchMenu->insertItem( i18n( "Resign" ), Core, SLOT(matchMenu(int)), 0, MENU_RESIGN );
	matchMenu->setItemEnabled( MENU_RESIGN, FALSE );
	matchMenu->setWhatsThis( MENU_RESIGN, i18n( "Use this to concede the match to your opponent." ) );
	// MENU_CALL_FLAG
	matchMenu->insertItem( i18n( "&Call Flag" ), Core, SLOT(matchMenu(int)), 0, MENU_CALL_FLAG );
	matchMenu->setItemEnabled( MENU_CALL_FLAG, FALSE );
	matchMenu->setWhatsThis( MENU_CALL_FLAG, i18n( "Use this to declare the game over, due to your opponent being out of time." ) );
	// MENU_HINT
/*	matchMenu->insertItem( i18n( "&Hint" ), Core, SLOT(matchMenu(int)), 0, MENU_HINT );
	matchMenu->setItemEnabled( MENU_HINT, FALSE );
	matchMenu->setWhatsThis( MENU_HINT, i18n( "This will ask your opponent for a hint." ) );*/
	// MENU_MOVE_NOW
	matchMenu->insertItem( i18n( "Move &Now" ), Core, SLOT(matchMenu(int)), 0, MENU_MOVE_NOW );
	matchMenu->setItemEnabled( MENU_MOVE_NOW, FALSE );
	matchMenu->setWhatsThis( MENU_MOVE_NOW, i18n( "Clicking this option will force your opponent to move immediately." ) );
	// MENU_ORIENTATION
	matchMenu->insertItem( i18n( "&Flip View" ), Core, SLOT(matchMenu(int)), 0, MENU_ORIENTATION );
	matchMenu->setItemEnabled( MENU_ORIENTATION, FALSE );
	matchMenu->setWhatsThis( MENU_ORIENTATION, i18n( "This will reverse the chessboard's orientation by 180 degrees." ) );
	// MENU_PONDER
	matchMenu->insertItem( i18n( "&Ponder" ), this, SLOT(Settings(int)), 0, MENU_PONDER );
	matchMenu->setItemChecked( MENU_PONDER, Resource->OPTION_Ponder );
	matchMenu->setItemEnabled( MENU_PONDER, FALSE );
	matchMenu->setWhatsThis( MENU_PONDER, i18n( "This toggles your opponent's ability to think while it's your turn." ) );
	matchMenu->insertSeparator();
	// MENU_PAUSE
	matchMenu->insertItem( QIconSet( Resource->LoadIcon( QString("player_pause"), KIcon::Small ) ),
												i18n( "Pause" ), this, SLOT( Settings(int) ),  0, MENU_PAUSE );
	matchMenu->setItemEnabled( MENU_PAUSE, FALSE );
	matchMenu->setWhatsThis( MENU_PAUSE, i18n( "Select this to pause the clock for this match." ) );
	
        
        difficultyMenu->setCheckable(true);
        //MENU_DIFFICULTY_10
        difficultyMenu->insertItem( i18n( "Very easy" ), this, SLOT(Settings(int)), 0, MENU_DIFFICULTY_VERY_EASY );
        //MENU_DIFFICULTY_20
        difficultyMenu->insertItem( i18n( "Easy" ), this, SLOT(Settings(int)), 0, MENU_DIFFICULTY_EASY );
        //MENU_DIFFICULTY_30
        difficultyMenu->insertItem( i18n( "Moderate" ), this, SLOT(Settings(int)), 0, MENU_DIFFICULTY_MODERATE );
        //MENU_DIFFICULTY_40
        difficultyMenu->insertItem( i18n( "Hard" ), this, SLOT(Settings(int)), 0, MENU_DIFFICULTY_HARD );
        //MENU_DIFFICULTY_50
        difficultyMenu->insertItem( i18n( "Very hard" ), this, SLOT(Settings(int)), 0, MENU_DIFFICULTY_VERY_HARD);
        difficultyMenu->setCheckable(true);
        
        
          if (Resource->difficulty=="very_easy") {
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
            }
          else if (Resource->difficulty=="easy") {
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
            }
          else if (Resource->difficulty=="moderate") {
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
            }
          else if (Resource->difficulty=="hard") {
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
            }
          else if (Resource->difficulty=="very_hard") {
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,true);
        }
        /*
			drawMenu menu
                        
                      
	*/
	// MENU_OFFER_DRAW
	drawMenu->insertItem( i18n( "&Offer Draw" ), Core, SLOT(matchMenu(int)), 0, MENU_OFFER_DRAW );
	drawMenu->setWhatsThis( MENU_OFFER_DRAW, i18n( "Clicking this will inform your opponent that you are willing draw the game." ) );
	// MENU_ACCEPT_DRAW
	drawMenu->insertItem( i18n( "&Accept Draw" ), Core, SLOT(matchMenu(int)), 0, MENU_ACCEPT_DRAW );
	drawMenu->setWhatsThis( MENU_ACCEPT_DRAW, i18n( "Clicking this will accept a draw offered by your opponent." ) );
	// MENU_REJECT_DRAW
	drawMenu->insertItem( i18n( "&Reject Draw" ), Core, SLOT(matchMenu(int)), 0, MENU_REJECT_DRAW );
	drawMenu->setWhatsThis( MENU_REJECT_DRAW, i18n( "Clicking this will reject a draw offered by your opponent." ) );
	// MENU_IGNORE_DRAW
	drawMenu->insertItem( i18n( "&Ignore Draw" ), Core, SLOT(matchMenu(int)), 0, MENU_IGNORE_DRAW );
	drawMenu->setWhatsThis( MENU_IGNORE_DRAW, i18n( "Clicking this will ignore future draw offers from your opponent." ) );
	/*
			fileMenu menu
	*/
	// MENU_NEWGAME
	fileMenu->insertItem( i18n( "&New Game" ), newGames, MENU_NEWGAME );
	fileMenu->setWhatsThis( MENU_NEWGAME, i18n( "This allows you to begin a new match." ) );
	// MENU_LOAD
	fileMenu->insertItem( i18n( "&Load Game..." ), Core, SLOT( load() ),0, MENU_LOAD );
	fileMenu->setWhatsThis( MENU_LOAD, i18n( "The Open command will allow you to select a previously saved game and play it again." ) );
	// MENU_CLOSE
	fileMenu->insertItem( i18n( "&Close Game" ), Core, SLOT( clearMatch() ), 0, MENU_CLOSE );
	fileMenu->setItemEnabled( MENU_CLOSE, FALSE );
	fileMenu->setWhatsThis( MENU_CLOSE, i18n( "This command removes the current match." ) );
	// MENU_CLOSEALL
	fileMenu->insertItem( i18n( "Close All" ), Core, SLOT( clearAll() ), 0, MENU_CLOSEALL );
	fileMenu->setItemEnabled( MENU_CLOSEALL, FALSE );
	fileMenu->setWhatsThis( MENU_CLOSEALL, i18n( "This command will remove all matches that are currently loaded." ) );
	fileMenu->insertSeparator();
	// MENU_SAVE
	fileMenu->insertItem( i18n( "&Save Game" ), this, SLOT( SaveGame() ), 0, MENU_SAVE );
	fileMenu->setItemEnabled( MENU_SAVE, FALSE );
	fileMenu->setWhatsThis( MENU_SAVE, i18n( "The Save command will allow you to store a copy of your current game for later use." ) );
	// MENU_SAVEAS
	fileMenu->insertItem( i18n( "Save Game &As..." ), this, SLOT( SaveGameAs() ), 0, MENU_SAVEAS );
	fileMenu->setItemEnabled( MENU_SAVEAS, FALSE );
	fileMenu->setWhatsThis( MENU_SAVEAS, i18n( "The Save command will allow you to store a copy of your current game for later use." ) );
	//fileMenu->insertSeparator();
	// MENU_CONNECT
// 	fileMenu->insertItem( QIconSet( Resource->LoadIcon( QString("connect_creating"), KIcon::Small ) ),
// 												i18n( "Connect to Server" ), this, SLOT( netConnect() ), 0, MENU_CONNECT );
	fileMenu->setWhatsThis( MENU_CONNECT, i18n( "Clicking this will connect Knights with an internet chess server." ) );
	//fileMenu->insertSeparator();
	// MENU_PRINT
	//fileMenu->insertItem( i18n( "&Print Notation..." ), this, SLOT( SaveGame() ), 0, MENU_PRINT );
// 	fileMenu->setItemEnabled( MENU_PRINT, FALSE );
// 	fileMenu->setWhatsThis( MENU_PRINT, i18n( "The Print command will allow you to print this game's notation on your printer." ) );
// 	fileMenu->insertSeparator();
	// MENU_QUIT
// 	fileMenu->insertItem( i18n( "&Quit" ), qApp, SLOT(quit()), 0, MENU_QUIT );
	//fileMenu->setWhatsThis( MENU_QUIT, i18n( "The Quit command will stop the current game and exit Knights." ) );
	/*
			settingsMenu menu
	*/
	settingsMenu->setCheckable(TRUE);
	// MENU_PLAYWHITE
	settingsMenu->insertItem( i18n( "Play &White" ), this, SLOT(Settings(int)), 0, MENU_PLAYWHITE );
	settingsMenu->setItemChecked(MENU_PLAYWHITE, !Resource->OPTION_Play_Black );
	settingsMenu->setWhatsThis( MENU_PLAYWHITE, i18n( "If checked, this option tells Knights that you will play as the White army when you play vs. the computer." ) );
	// MENU_PLAYBLACK
	settingsMenu->insertItem( i18n( "Play &Black" ), this, SLOT(Settings(int)), 0, MENU_PLAYBLACK );
	settingsMenu->setItemChecked(MENU_PLAYBLACK, Resource->OPTION_Play_Black );
	settingsMenu->setWhatsThis( MENU_PLAYBLACK, i18n( "If checked, this option tells Knights that you will play as the Black army when you play vs. the computer." ) );
	settingsMenu->insertSeparator();
         settingsMenu->insertItem("&Difficulty",difficultyMenu,MENU_DIFFICULTY);
         settingsMenu->setItemEnabled( MENU_DIFFICULTY, TRUE );
	// MENU_BINDINGS_DIALOG
// 	settingsMenu->insertItem( QIconSet( Resource->LoadIcon( QString("key_bindings"), KIcon::Small ) ),
// 														i18n( "Configure &Key Bindings..." ), this, SLOT(openKeyBindingDialog()), 0, MENU_BINDINGS_DIALOG );
	settingsMenu->setWhatsThis( MENU_BINDINGS_DIALOG, i18n( "Click this if you want to change the keyboard shortcuts that Knights uses." ) );
	// MENU_SETTINGS_DIALOG
	settingsMenu->insertItem(i18n( "&Configure Knights..." ), this, SLOT(openSettingsDialog()), 0, MENU_SETTINGS_DIALOG );
	settingsMenu->setWhatsThis( MENU_SETTINGS_DIALOG, i18n( "This opens a new window which allows you to customize Knights to your particular tastes." ) );
	
        
        /*
			tutorialMenu menu
	*/
	tutorialMenu->setCheckable(TRUE);
	// MENU_OPEN_TUTORIAL
	tutorialMenu->insertItem( i18n( "Begin a Tutorial" ), this, SLOT(Settings(int)), 0, MENU_OPEN_TUTORIAL );
//	tutorialMenu->setWhatsThis( MENU_OPEN_TUTORIAL, i18n( "If checkeenuter." ) );
	
        helpMenu->insertItem("&About",this,SLOT(about()));
        
        
        
        /*
			topMenu menu
	*/
        
	topMenu->insertItem( i18n( "&File" ), fileMenu );
        
	topMenu->insertItem( i18n( "&Match" ), matchMenu );
        
	topMenu->insertItem( i18n( "&Settings" ), settingsMenu );
        
        topMenu->insertItem("&Help",helpMenu);
//	topMenu->insertItem( i18n( "&Tutorials" ), tutorialMenu );

	topMenu->insertSeparator();
        qDebug("Knights::init 3");        
	//topMenu->insertItem( i18n( "&Help" ), help );
	/* Init Message */

        #warning FIXME
	Message->setAlignment( Qt::AlignLeft | Qt::AlignVCenter );
	/* Init White Time Label */
	GroupWhite.setColor( QColorGroup::Background, Resource->COLOR_White );
	GroupWhite.setColor( QColorGroup::Foreground, Resource->COLOR_Black );
	whiteTimeLabel->setPalette( QPalette( GroupWhite, GroupWhite, GroupWhite ) );
	whiteTimeLabel->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );
	whiteTimeLabel->setAlignment( Qt::AlignCenter | Qt::SingleLine );
	/* Init Black Time Label */
	GroupBlack.setColor( QColorGroup::Background, Resource->COLOR_Black );
	GroupBlack.setColor( QColorGroup::Foreground, Resource->COLOR_White );
	blackTimeLabel->setPalette( QPalette( GroupBlack, GroupBlack, GroupBlack ) );
	blackTimeLabel->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );
	blackTimeLabel->setAlignment( Qt::AlignCenter | Qt::SingleLine );
	/* Configure self */
	setCentralWidget( MainFrame );
	InitAll = FALSE;
	resizeMainFrame();
  	show();
	setStatusBar( READY );
//	if( SplashScreen != NULL ) delete SplashScreen;
	/* Run the Setup Wizard if needed */
	/*if( Resource->Config_Version < CONFIG_VERSION )
	{
		
		Wizard = new wiz_setup( this, "wiz_setup", Resource );
		Wizard->exec();
		delete Wizard;
		resizeMainFrame();
		Resource->Config_Version = CONFIG_VERSION;
	}*/
	/* Begin loading file from command line */
/*	if( args->count() )
		Core->load( QString( args->arg( 0 ) ) );
                
	else*/
//         if (!argsFileNaWizard = new wiz_setup( this, "wiz_setup", Resource );
// 		Wizard->exec();
// 		delete Wizard;
// 		resizeMainFrame();
// 		Resource->Config_Version = CONFIG_VERSION;
// 	}*/
	/* Begin loading file from command line */
/*	if( args->count() )
		Core->load( QString( args->arg( 0 ) ) );
                
	else*/
        if (!argsFileName.isEmpty())
          Core->load(argsFileName);
        else
        
	{
		/* Bring up a match or pgn file */
		switch( Resource->OPTION_On_Init )
		{
			case MENU_SOLITARE:
				Core->addMatch( MENU_SOLITARE );
				break;
			case MENU_VS_PC:
				//if( !Resource->engines.count() ) break;
				Core->addMatch( MENU_VS_PC );
				break;
			case MENU_CONNECT:
				netConnect();
				break;
			default:
				break;
		}
	}
        
        kdDebug() << "Knights::init end" << endl;
	return TRUE;
}

void Knights::setDocument(const QString &Document)
{
kdDebug() << "Knights::setDocument: " << Document << endl;

DocLnk lnk(Document,true);
Core->load(lnk);

}
///////////////////////////////////////
//
//	Knights::resizeMainFrame
//
///////////////////////////////////////
void Knights::resizeMainFrame(void)
{
	QStyle& Style = QApplication::style();
	QSize S_Console_Min;
	QSize S_Console_Max;
	QSize S_Message;
	QSize S_Menu;
	
	int statusY(0);
	int statusX(0);	
	int statusHeight(0);
	
	/* Get some numbers */
	margin = Style.defaultFrameWidth();
	/* Take care of the Core first */
	Core->move( 10, 0 );
	Core->resize();
	//if( console != NULL ) console->saveGeometry();
	/* Get our size hints */
	S_Message = Message->sizeHint();
	Message->resize(S_Message + QSize(10,0));
	S_Menu = topMenu->sizeHint();
	statusHeight = S_Message.height() + ( 2 * margin ) + 5;
	statusY += Core->height() + margin + statusHeight + margin;
	statusX = Core->width();
	/* Now the console */
        #ifdef CONSOLE
	if( ( console != NULL ) && ( Resource->OPTION_Console_Attach ) )
	{
		ResizeFlag = TRUE;
		console->reparent( MainFrame, 0, QPoint(0,0), TRUE );
		switch( Resource->OPTION_Console_Orientation )
		{
			/* To the Right the Core */
			case 1:
				S_Console_Min.setWidth( 128 );
				S_Console_Max.setWidth( 2048 );
				S_Console_Min.setHeight( Core->height() + statusHeight );
				S_Console_Max.setHeight( Core->height() + statusHeight );
				console->setMinimumSize( S_Console_Min );
				console->setMaximumSize( S_Console_Max );
				console->resize( Resource->Console_Right );
				console->resetSplitter();
				console->move( Core->width() + margin, 0 );
				break;
			/* Under the Core */
			case 0:	// Fall Through
			default:
				S_Console_Min.setWidth( Core->width() );
				S_Console_Max.setWidth( Core->width() );
				S_Console_Min.setHeight( 128 );
				S_Console_Max.setHeight( 2048 );
				console->setMinimumSize( S_Console_Min );
				console->setMaximumSize( S_Console_Max );
				console->resize( Resource->Console_Bottom );
				console->resetSplitter();
				console->move( 0, Core->height() + margin );
				statusY += console->height() + margin;
				break;
		}
		ResizeFlag = FALSE;
	}
	else
        
	{
		S_Console_Min.setWidth( 128 );
		S_Console_Min.setHeight( 128 );
		S_Console_Max.setWidth(2048);
		S_Console_Max.setHeight(2048);
		if( console != NULL )
		{
			console->reparent( 0, Qt::WType_TopLevel | Qt::WDestructiveClose, Resource->Console_Detached_Loc, TRUE );
			console->setMinimumSize( S_Console_Min );
			console->setMaximumSize( S_Console_Max );
			console->resize( Resource->Console_Detached );
			console->resetSplitter();
			console->setCaption( i18n("Console - Knights") );
		}
		S_Console_Min.setWidth(0);
		S_Console_Min.setHeight(0);
		S_Console_Max.setWidth(0);
		S_Console_Max.setHeight(0);
	}
        
	/* And finally, our main widget */
 	if( ( console == NULL ) || ( !Resource->OPTION_Console_Attach ) )
	{
		MainFrame->setFixedSize( statusX, statusY );
		setFixedSize( statusX, statusY + S_Menu.height());
	}
	else
        #endif
	{
        
		if( Resource->OPTION_Console_Orientation == 0 )
		{
			MainFrame->setMinimumSize(	Core->width() + 15,
																	Core->height() + statusHeight );
			MainFrame->setMaximumSize(	Core->width() + 15,
																	Core->height() + statusHeight + margin + S_Console_Max.height() );
			setMinimumSize( 240,
											Core->height() + S_Menu.height() + ( margin * 3 ) + 8 );
			setMaximumSize( 240,
											Core->height() + S_Menu.height() + ( margin * 3 ) + S_Console_Max.height() + 8 );
			resize( 240 ,
							statusY +S_Menu.height() + ( margin * 3 ) 
                                                        #ifdef CONSOLE 
                                                        + console->height()
                                                        #endif
                                                         + 10 );
		}
		if( Resource->OPTION_Console_Orientation == 1 )
		{
			MainFrame->setMinimumSize(	Core->width() + margin + 15,
																	statusY );
			MainFrame->setMaximumSize(	15 +Core->width() + margin + S_Console_Max.width() ,
																	statusY );
			setMinimumSize( 240,
											statusY + S_Menu.height()  + 8 );
			setMaximumSize(240,
											statusY + S_Menu.height() + 8 );
			resize(240
                        				#ifdef CONSOLE
                                                        + console->width()
                                                        #endif
							,statusY + S_Menu.height() + 8 );
		}
	}
	/* enable or disable games in the menu */
        
	//if( Resource->engines.count() )
	{
		newGames->setItemEnabled( MENU_VS_PC, TRUE );
		newGames->setItemEnabled( MENU_PC_VS_PC, TRUE );
	}
// 	//else
// 	{
// 		newGames->setItemEnabled( MENU_VS_PC, FALSE );
// 		newGames->setItemEnabled( MENU_PC_VS_PC, FALSE );
// 	}
	if( Resource->servers.count() )
	{
		fileMenu->setItemEnabled( MENU_CONNECT, TRUE );
	}
	else
	{
		fileMenu->setItemEnabled( MENU_CONNECT, FALSE );
	}
	//newGames->setItemEnabled( MENU_VS_EMAIL, FALSE );
}
///////////////////////////////////////
//
//	Knights::resizeEvent
//
///////////////////////////////////////
void Knights::resizeEvent( QResizeEvent * )
{
	QSize S_Message;
	QSize newSize;
	int tmp(0);
	int statusHeight(0);
	int statusY(0);
	int statusX(0);
	int gridX(0);	
	
	if( ResizeFlag ) return;
	/* Get the height & Y of the status bar */
	gridX = (Core->width() / 8);
	S_Message = Message->sizeHint() + QSize( 2, 2 );
	statusHeight = S_Message.height() + ( 2 * margin );
	Resource->Widget_Height = statusHeight;
	statusY += Core->height() + margin;
	#ifdef CONSOLE
        if( ( console != NULL ) && ( Resource->OPTION_Console_Attach ) )
	{
		switch( Resource->OPTION_Console_Orientation )
		{
			/* To the Right the Core */
			case 1:
				newSize.setWidth( width() - ( margin * 2 ) - Core->width() );
				newSize.setHeight( console->height() );
				console->resize( newSize.width() , newSize.height() );
				MainFrame->resize(	newSize.width() + Core->width() + ( margin * 2 ),
														MainFrame->height() );
				break;
			/* Under the board */
			case 0:	// Fall Through
			default:
				newSize.setWidth( console->width() );
				newSize.setHeight( height() - margin - Core->height() - statusHeight );
				console->resize( newSize.width() , newSize.height() );
				MainFrame->resize(	MainFrame->width(),
														newSize.height() + Core->height() + statusHeight + margin );
				break;
		}
	}
        #endif
	if( InitAll ) return;
	/* Do the Message box */
	tmp = gridX * 3;
	Message->setFixedSize( tmp - ( margin * 2 ), statusHeight );
	Message->move( 0, statusY );
	statusX = tmp + 15;
	/* Do the White Time */
	tmp = gridX + ( gridX / 2 );
	whiteTimeLabel->setFixedSize( tmp - margin, statusHeight );
	whiteTimeLabel->move( statusX, statusY );
	statusX += tmp;
	/* Do the Black Time */
	tmp = gridX + ( gridX / 2 );
	blackTimeLabel->setFixedSize( tmp - margin, statusHeight );
	blackTimeLabel->move( statusX, statusY );
	statusX += tmp;
	/* Do the Notation Bar */
	tmp = gridX * 2;
	notationBar->setFixedSize( tmp - margin + 3, statusHeight );
	notationBar->move( statusX, statusY );
	statusX += tmp;
}
///////////////////////////////////////
//
//	Knights::hideEvent
//
///////////////////////////////////////
void Knights::hideEvent( QHideEvent* )
{
	if( !Resource->OPTION_Pause_On_Minimize ) return;
	Core->matchMenu( MENU_PAUSEALL );
	Minimized = TRUE;
}
///////////////////////////////////////
//
//	Knights::showEvent
//
///////////////////////////////////////
void Knights::showEvent( QShowEvent* )
{
	if( !Minimized ) return;
	Core->matchMenu( MENU_PAUSEALL );
	Minimized = FALSE;
}
///////////////////////////////////////
//
//	Knights::wheelEvent
//
///////////////////////////////////////
void Knights::wheelEvent( QWheelEvent *event )
{
	event->accept();
	if( event->delta() > 0 ) PrevNotation();
	if( event->delta() < 0 ) NextNotation();
}
///////////////////////////////////////
//
//	Knights::SelectTheme
//
///////////////////////////////////////
void Knights::SelectTheme(const QString & theme )
{
	kdDebug() << "Knights::SelectTheme" << endl;
        //Resource->setTheme( boardIndex, chessmenIndex );
        Resource->setCurrentChessmen(theme);
        Resource->setTheme(-1,-1);
	resizeMainFrame();
}

void Knights::SelectBoardTheme(const QString & theme)
{
        Resource->setCurrentBoard(theme);
        Resource->setTheme(-1,-1);
	resizeMainFrame();        

}

void Knights::SelectTheme(int boardIndex, int chessmenIndex )
{
	
	Resource->setTheme( boardIndex, chessmenIndex );
//         Resource->setCurrentTheme(theme);
//         Resource->setTheme(-1,-1);
	resizeMainFrame();
}


///////////////////////////////////////
//
//	Knights::setStatusBar
//
///////////////////////////////////////
void Knights::setStatusBar( const int ID, const QString &MSG )
{
	pgn *tmpPGN;
	/* Game comments as specified in http://www.schachprobleme.de/chessml/faq/pgn/
			Section 10: Numeric Annotation Glyphs */
	if( ( ID & COMMENT ) == COMMENT )
	{
		tmpPGN = new pgn;
		Message->setText( tmpPGN->getNAG( ID - COMMENT ) );
		delete tmpPGN;
		return;
	}
	/* Knights specific  s */
	switch( ID )
	{
		/* Error Codes */
		case BOOK_ERROR_1:
			Message->setText( i18n( " Error with white engine" ) );
			QMessageBox::information( this,
													i18n("You selected %1 to play white,\nbut it can only be used as a book engine.\nPlease select another engine to play white.").arg( MSG ),
													i18n("White Engine Problem") );
			break;
		case BOOK_ERROR_2:
			Message->setText( i18n( " Error with white book engine" ) );
			QMessageBox::information( this,
													i18n("You selected %1 to play white's book,\nbut it can only be used as a regular engine.\nPlease select another engine to play white's book.").arg( MSG ),
													i18n("White Book Engine Problem") );
			break;
		case BOOK_ERROR_3:
			Message->setText( i18n( " Error with black engine" ) );
			QMessageBox::information( this,
													i18n("You selected %1 to play black,\nbut it can only be used as a book engine.\nPlease select another engine to play black.").arg( MSG ),
													i18n("Black Engine Problem") );
			break;
		case BOOK_ERROR_4:
			Message->setText( i18n( " Error with black book engine" ) );
			QMessageBox::information( this,
													i18n("You selected %1 to play black's book,\nbut it can only be used as a regular engine.\nPlease select another engine to play black's book.").arg( MSG ),
													i18n("Black Book Engine Problem") );
			break;
		case ENGINE_DIED_ERROR:
			Message->setText( i18n( " The computer opponent assigned to play %1 has crashed" ).arg( MSG ) );
			break;
		case LOAD_ERROR:
			Message->setText( i18n( " There was an error while loading the file" ) );
			break;
		case SAVE_ERROR:
			Message->setText( i18n( " There was an error while saving the file" ) );
			break;
		/* Standard Codes */
		case LOAD_OK:
			Message->setText( i18n( " Loading complete" ) );
			break;
		case SAVE_OK:
			Message->setText( i18n( " Saving complete" ) );
			break;
		case READING_FILE:
			Message->setText( i18n( " Reading File" ) );
			break;
		case NO_MOVE_WHILE_REVIEW:
			QMessageBox::information(this,"Can not move a piece while reviewing", "Sorry, you can not move pieces\nwhen reviewing the game");
			//Message->setText( i18n( " Can not move a \npiece while reviewing" ) );
			break;
		case ILLEGAL_MOVE:
			Message->setText( i18n( " Illegal Move" ) );
			break;
		case WHITE_TURN:
			Message->setText( i18n( " White's turn" ) );
			break;
		case BLACK_TURN:
			Message->setText( i18n( " Black's turn" ) );
			break;
		case WHITE_WIN:
			Message->setText( i18n( " White wins" ) );
			break;
		case BLACK_WIN:
			Message->setText( i18n( " Black wins" ) );
			break;
		case WHITE_CHECKMATE:
			Message->setText( i18n( " Checkmate,\nWhite wins" ) );
			break;
		case BLACK_CHECKMATE:
			Message->setText( i18n( " Checkmate,\nBlack wins" ) );
			break;
		case WHITE_RESIGN:
			Message->setText( i18n( " White resigns" ) );
			break;
		case BLACK_RESIGN:
			Message->setText( i18n( " Black resigns" ) );
			break;
		case WHITE_FLAG:
			Message->setText( i18n( " White's flag fell" ) );
			break;
		case BLACK_FLAG:
			Message->setText( i18n( " Black's flag fell" ) );
			break;
		case WHITE_CALL_FLAG:
			Message->setText( i18n( " Black's flag \ncalled, White wins" ) );
			break;
		case BLACK_CALL_FLAG:
			Message->setText( i18n( " White's flag \ncalled, Black wins" ) );
			break;
		case GAME_DRAW:
			Message->setText( i18n( " Draw game" ) );
			break;
		case GAME_50_MOVES:
			Message->setText( i18n( " 50 moves rule,\ndraw game" ) );
			break;
		case WAITING:
			Message->setText( i18n( " Starting computer players, please wait" ) );
			break;
		case PAUSED:
			Message->setText( i18n( " Game paused" ) );
			break;
		case WHITE_DRAW_OFFER:
			Message->setText( i18n( " White offers draw" ) );
			break;
		case BLACK_DRAW_OFFER:
			Message->setText( i18n( " Black offers draw" ) );
			break;
		case LOST_CONTACT:
			Message->setText( i18n( " Lost contact with opponent" ) );
                        break;
                case WHITE_CHECKED:
                	//QMessageBox::information(this,"Check","Black has checked white");
                	//Message->setText( i18n( " Lost contact with opponent" ) );
                        break;
                case BLACK_CHECKED:
                 	//QMessageBox::information(this,"Check","White has checked black");
                	//Message->setText( i18n( " White checked Black " ) );
                        break;
  	case READY:
		default:
			Message->setText( i18n( " Ready" ) );
			break;
	}
}
///////////////////////////////////////
//
//	Knights::setClocks
//
///////////////////////////////////////
void Knights::setClocks( void )
{
	whiteTimeLabel->setText( Core->clock( WHITE ) );
	blackTimeLabel->setText( Core->clock( BLACK ) );
	if( Core->flag( WHITE ) )
		if( Core->blackInput() == PLAYERLOCAL )
			matchMenu->setItemEnabled( MENU_CALL_FLAG, TRUE );
		else
			matchMenu->setItemEnabled( MENU_CALL_FLAG, FALSE );
	if( Core->flag( BLACK ) )
		if( Core->whiteInput() == PLAYERLOCAL )
			matchMenu->setItemEnabled( MENU_CALL_FLAG, TRUE );
		else
			matchMenu->setItemEnabled( MENU_CALL_FLAG, FALSE );
}
///////////////////////////////////////
//
//	Knights::setNotation
//
///////////////////////////////////////
void Knights::setNotation( void )
{
	QStringList *list;
	QStringList::Iterator IT;
	int count(0);

	setCaption( Core->caption() );
	notationBar->clear();
	list = Core->notation();
	/*
			Several menu items' status changes based upon the availability
			of notation data. Therefore, we'll enable & disable those here
			since we've gathered the notation data anyway.
	*/
	if( list == NULL )
	{
		/* Disable Save & Print Functions */
		fileMenu->setItemEnabled( MENU_SAVE, FALSE );
		fileMenu->setItemEnabled( MENU_SAVEAS, FALSE );
		fileMenu->setItemEnabled( MENU_PRINT, FALSE );
		matchMenu->setItemEnabled( MENU_RETRACT, FALSE );
		return;
	}
	if( Core->modified() ) fileMenu->setItemEnabled( MENU_SAVE, TRUE );
	else fileMenu->setItemEnabled( MENU_SAVE, FALSE );
	if( ( ( Core->onMove() == WHITE ) && ( Core->whiteInput() == PLAYERLOCAL ) && ( Core->blackInput() == PLAYERPC ) ) ||
			( ( Core->onMove() == BLACK ) && ( Core->blackInput() == PLAYERLOCAL ) && ( Core->whiteInput() == PLAYERPC ) ) )
			if( list->count() )
				matchMenu->setItemEnabled( MENU_RETRACT, TRUE );
			else
				matchMenu->setItemEnabled( MENU_RETRACT, FALSE );
	else
		matchMenu->setItemEnabled( MENU_RETRACT, FALSE );
	fileMenu->setItemEnabled( MENU_SAVEAS, TRUE );
	/* Uncomment only when printing is enabled w/ KDE3 support */
	//	fileMenu->setItemEnabled( MENU_PRINT, TRUE );

	/* Create the List */
	for( IT = list->begin(); IT != list->end(); ++IT )
	{
			notationBar->insertItem( (*IT), count++ );
	}
	notationBar->setCurrentItem( --count );
	delete list;
}
///////////////////////////////////////
//
//	Knights::PrevNotation
//
///////////////////////////////////////
void Knights::PrevNotation( void )
{
	int tmp( notationBar->currentItem() - 1 );
	Core->review( tmp );	// Do this before the bounds checking in case this is examine mode
	if( tmp < 0 ) return;
	notationBar->setCurrentItem( tmp );
}
///////////////////////////////////////
//
//	Knights::NextNotation
//
///////////////////////////////////////
void Knights::NextNotation( void )
{
	int tmp( notationBar->currentItem() + 1 );
	Core->review( tmp );	// Do this before the bounds checking in case this is examine mode
	if( tmp > ( notationBar->count() - 1 ) ) return;
	notationBar->setCurrentItem( tmp );
}
///////////////////////////////////////
//
//	Knights::initMatch
//
///////////////////////////////////////
void Knights::initMatch( void )
{
	setNotation();
        
	/* Are there any players? ( ie - is this a match or a null? */
	if( ( Core->whiteInput() == Null ) || ( Core->blackInput() == Null ) )
	{
		fileMenu->setItemEnabled( MENU_CLOSE, FALSE );
		fileMenu->setItemEnabled( MENU_CLOSEALL, FALSE );
		matchMenu->setItemEnabled( MENU_ORIENTATION, FALSE );
		whiteTimeLabel->setText( "" );
		blackTimeLabel->setText( "" );
		setStatusBar( READY );
	}
	else
	{
		fileMenu->setItemEnabled( MENU_CLOSE, TRUE );
		fileMenu->setItemEnabled( MENU_CLOSEALL, TRUE );
		matchMenu->setItemEnabled( MENU_ORIENTATION, TRUE );
	}
	/* Is there a local player? */
	if( ( Core->whiteInput() == PLAYERLOCAL ) || ( Core->blackInput() == PLAYERLOCAL ) )
	{
		matchMenu->setItemEnabled( MENU_DRAW, TRUE );
		matchMenu->setItemEnabled( MENU_RESIGN, TRUE );
	}
	else
	{
		matchMenu->setItemEnabled( MENU_DRAW, FALSE );
		matchMenu->setItemEnabled( MENU_RESIGN, FALSE );
	}
	/* Is there a PC player? */
 	if( ( Core->whiteInput() == PLAYERPC ) || ( Core->blackInput() == PLAYERPC ) )
 	{
 		matchMenu->setItemEnabled( MENU_MOVE_NOW, TRUE );
 		matchMenu->setItemEnabled( MENU_HINT, TRUE );
 		matchMenu->setItemEnabled( MENU_PONDER, TRUE );
 		matchMenu->setItemEnabled( MENU_PAUSE, TRUE );
 	}
	else
	{
		matchMenu->setItemEnabled( MENU_MOVE_NOW, FALSE );
 		matchMenu->setItemEnabled( MENU_HINT, FALSE );
 		matchMenu->setItemEnabled( MENU_PONDER, FALSE );
 		matchMenu->setItemEnabled( MENU_PAUSE, FALSE );
	}
	/* Is there a TCP player? */
	if( ( Core->whiteInput() == PLAYERTCP ) || ( Core->blackInput() == PLAYERTCP ) )
	{
		settingsMenu->setItemEnabled( MENU_PLAYWHITE, FALSE );
		settingsMenu->setItemEnabled( MENU_PLAYBLACK, FALSE );
	}
	else
	{
		settingsMenu->setItemEnabled( MENU_PLAYWHITE, TRUE );
		settingsMenu->setItemEnabled( MENU_PLAYBLACK, TRUE );
	}
        
        if (Core->engineHints==false)
           matchMenu->setItemEnabled(MENU_HINT,false);
        else 
           matchMenu->setItemEnabled(MENU_HINT,true);
        
         if (Core->engineUndos==false)
           matchMenu->setItemEnabled(MENU_RETRACT,false);
         else
           matchMenu->setItemEnabled(MENU_RETRACT,true);
           
}
///////////////////////////////////////
//
//	Knights::netConnect
//
///////////////////////////////////////
void Knights::netConnect( void )
{
#ifdef INTERNETPLAY
qDebug("Knights::netConnect");
	netconcomm *NetTemp(NULL);
	if( Core->isOnline() )
	{
//		delete console;
		consoleDestroyed();
	}
	else
	{
		NetTemp = Core->addServer();
		fileMenu->changeItem( MENU_CONNECT,
													QIconSet( Resource->LoadIcon( QString("connect_no"), KIcon::Small ) ),
													i18n( "Disconnect from Server" ) );
		console = new Console( 0, "console", Resource, NetTemp );
		console = new Console( 0, "console", Resource, NetTemp );
		console->margin = margin;
		resizeMainFrame();
		connect( console, SIGNAL( submitText( const QString& ) ), Core, SLOT( submitMessage( const QString& ) ) );
		connect( console, SIGNAL( destroyed() ), this, SLOT( consoleDestroyed() ) );
// 		Accel->connectItem( "Page Up", console, SLOT( pageUp() ) );
// 		Accel->connectItem( "Page Down", console, SLOT( pageDown() ) );
// 		Accel->connectItem( "Last History Item", console, SLOT( historyBackward() ) );
// 		Accel->connectItem( "Next History Item", console, SLOT( historyForward() ) );
// 		Accel->connectItem( "Tell Reply", console, SLOT( replyPrivate() ) );
// 		Accel->connectItem( "Channel Reply", console, SLOT( replyChannel() ) );
// 		Accel->connectItem( "Kibitz", console, SLOT( kibitz() ) );
// 		Accel->connectItem( "Whisper", console, SLOT( whisper() ) );
// 		Accel->connectItem( "Enter Text", console, SLOT( getFocus() ) );

	}
#endif
}
///////////////////////////////////////
//
//	Knights::openSettingsDialog
//
///////////////////////////////////////
void Knights::openSettingsDialog( void )
{
	qDebug("Knights::openSettingsDialog");
        SettingsBase = new settingsBase( this, "settings", Resource );
        qDebug("Knights::openSettingsDialog 2");
        connect( SettingsBase, SIGNAL( themeChanged(const QString &) ), this, SLOT( SelectTheme(const QString &) ) );
        connect( SettingsBase, SIGNAL( themeBoardChanged(const QString &)),this,SLOT(SelectBoardTheme(const QString &)));
	connect( SettingsBase, SIGNAL( redrawBoard() ), Core, SLOT( resize() ) );
	connect( SettingsBase, SIGNAL( resetServer() ), Core, SLOT( resetServer() ) );
	
/*	if( console != NULL )
		connect( SettingsBase, SIGNAL( rebuildConsole() ), console, SLOT( setBG() ) );*/
	SettingsBase->showMaximized();
        //SettingsBase->resize(200,200);
}
///////////////////////////////////////
//
//	Knights::openKeyBindingDialog
//
///////////////////////////////////////
void Knights::openKeyBindingDialog( void )
{

}
///////////////////////////////////////
//
//	Knights::Settings
//
///////////////////////////////////////
void Knights::Settings(int opt)
{
	switch(opt)
	{
		case MENU_PLAYWHITE:
			Resource->OPTION_Play_Black = FALSE;
			settingsMenu->setItemChecked(MENU_PLAYWHITE, TRUE );
			settingsMenu->setItemChecked(MENU_PLAYBLACK, FALSE );
			Core->swapInput();
			break;
		case MENU_PLAYBLACK:
			Resource->OPTION_Play_Black = TRUE;
			settingsMenu->setItemChecked(MENU_PLAYWHITE, FALSE );
			settingsMenu->setItemChecked(MENU_PLAYBLACK, TRUE );
			Core->swapInput();
			break;
		case MENU_PONDER:
			Resource->OPTION_Ponder = 1 - Resource->OPTION_Ponder;
			matchMenu->setItemChecked(MENU_PONDER, Resource->OPTION_Ponder );
			Core->matchMenu( MENU_PONDER );
			break;
		case MENU_PAUSE:
			if( Core->paused() )
			{
				matchMenu->changeItem( MENU_PAUSE,
															QIconSet( Resource->LoadIcon( QString("player_pause"), KIcon::Small ) ),
															i18n( "Pause" ) );
			}
			else
			{
				matchMenu->changeItem( MENU_PAUSE,
															QIconSet( Resource->LoadIcon( QString("1rightarrow"), KIcon::Small ) ),
															i18n( "Resume" ) );
			}
			Core->matchMenu( MENU_PAUSE );
			break;
                 case MENU_DIFFICULTY_VERY_EASY:
                {
                Resource->difficulty="very_easy";
                difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,true);
                difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
                difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
                difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
                difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
                break;
                }
                case MENU_DIFFICULTY_EASY:
                {
                Resource->difficulty="easy";
                 difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
                break;
                }
                case MENU_DIFFICULTY_MODERATE:
                {
                Resource->difficulty="moderate";
                 difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
                break;
                }
                case MENU_DIFFICULTY_HARD:
                {
                Resource->difficulty="hard";
                            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,true);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,false);
                break;
                }
                case MENU_DIFFICULTY_VERY_HARD:
                {
                Resource->difficulty="very_hard";
                            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_EASY,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_MODERATE,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_HARD,false);
            difficultyMenu->setItemChecked(MENU_DIFFICULTY_VERY_HARD,true);
                break;
                }
		default:
			break;
	}
              
}
///////////////////////////////////////
//
//	Knights::SaveGame & Variants
//
///////////////////////////////////////
bool Knights::SaveGame( void )
{
	return Core->save( FALSE, FALSE );
}
bool Knights::SaveGamePrompt( void )
{
	return Core->save( TRUE, FALSE );
}
bool Knights::SaveGameAs( void )
{
	return Core->save( FALSE, TRUE );
}
///////////////////////////////////////
//
//	Knights::boardBigger
//
///////////////////////////////////////
void Knights::boardBigger( void )
{
	Resource->ThemeSize += 8;
	if( Resource->ThemeSize > IMAGE_MAX ) Resource->ThemeSize = IMAGE_MIN;
	SelectTheme( -1, -1 );
}
///////////////////////////////////////
//
//	Knights::boardSmaller
//
///////////////////////////////////////
void Knights::boardSmaller( void )
{
	Resource->ThemeSize -= 8;
	if( Resource->ThemeSize < IMAGE_MIN ) Resource->ThemeSize = IMAGE_MAX;
	SelectTheme( -1, -1 );
}
///////////////////////////////////////
//
//	Knights::consoleDestroyed
//
///////////////////////////////////////
void Knights::consoleDestroyed( void )
{
	#ifdef CONSOLE
        fileMenu->changeItem( MENU_CONNECT,
												QIconSet( Resource->LoadIcon( QString("connect_creating"), KIcon::Small ) ),
												i18n( "Connect to Server" ) );
	console = NULL;
	Core->removeServer();
	resizeMainFrame();
        #endif
}

