/***************************************************************************
                          knights.h  -  description
                             -------------------
    begin                : Thu Mar  1 10:43:51 CST 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KNIGHTS_H
#define KNIGHTS_H

#ifdef HAVE_CONFIG_H
//#include <config.h>
#endif

/* KDEBase */
//#include <kapp.h>
#include <qaccel.h>

#include <klocale.h>
#include <qpe/qpemenubar.h>
#include <qpe/qpetoolbar.h>
#include <qmainwindow.h>
//#include <khelpmenu.h>
//#include <kaboutdata.h>
#include <klocale.h>
#include <kcombobox.h>
#include <qpopupmenu.h>
//#include <kstandarddirs.h>
//#include <kstatusbar.h>
//#include <kcmdlineargs.h>
//#include <kmessagebox.h>
/* KFile */
#include <kfiledialog.h>
/* QT */
#include <qlayout.h>
#include <qlabel.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qpalette.h>
#include <qdatetime.h>
#include <qiconset.h>
/* Local */
#include "definitions.h"
#include "resource.h"
#include "core.h"
#include <qmainwindow.h>
#include <qpopupmenu.h>
#ifdef CONSOLE
#include "console.h"
#endif
#include "settingsbase.h"
#include <qevent.h>
//#include "splash.h"



/**
		Knights is the top-level widget of the project.
		It is responsable for creating the menu bar and it's contents,
		as well as creating an instance of the game itself ( class Grid )
**/
class Knights : public QMainWindow
{
  Q_OBJECT 
  public:
		//KAboutData			*aboutData;
		resource				*Resource;

//								    Knights(KCmdLineArgs *Args, QWidget* parent=0, const char *name=0);
								    Knights(QWidget* parent=0, const char *name=0,const QString& = "");								    ~Knights();
		bool						Init(void);
		void						BirthAll( void );
		void						closeEvent ( QCloseEvent * e );
	public slots:
		void						KillAll( void );
		/**		Yeah, they're sloppy, but I need my own geometry managment routines
					because I don't like the "default" look my statusbar was getting
					( double-height ). Plus, I want the console to appear only when needed. */
		void						resizeMainFrame( void );
		void						resizeEvent( QResizeEvent* );

		void						hideEvent( QHideEvent* );
		void						showEvent( QShowEvent* );
		void						wheelEvent( QWheelEvent *event );
		
		void						setStatusBar( const int ID, const QString& MSG=QString::null );
		
		void						setClocks( void );
		void						initMatch( void );
		
		void						setNotation( void );
		void						PrevNotation( void );
		void						NextNotation( void );
		
		void						SelectTheme( const QString & );
                void						SelectBoardTheme( const QString & );
                void						SelectTheme(int,int);
		void						Settings( int opt );
		void						openSettingsDialog( void );
		void						openKeyBindingDialog( void );
		bool						SaveGame( void );
		bool						SaveGamePrompt( void );
		bool						SaveGameAs( void );
		
										/**
										Will call routines to print the string to the console */
		void						netConnect( void );
                void						setDocument(const QString &);
                
                void						about();
		void 						enableDifficultyMenu(bool);
	protected:
		bool						queryClose( void );

	protected slots:
		void						boardSmaller( void );
		void						boardBigger( void );
		void						consoleDestroyed( void );

	private:
//		KCmdLineArgs 		*args;
		QPEMenuBar				*topMenu;
		QPopupMenu			*help;
		QPopupMenu			*newGames;
		QPopupMenu			*fileMenu;
		QPopupMenu			*settingsMenu;
                QPopupMenu			*difficultyMenu;
		QPopupMenu			*matchMenu;
		QPopupMenu			*drawMenu;
                QPopupMenu			*helpMenu;
		QPopupMenu			*tutorialMenu;
		KComboBox				*notationBar;
		QAccel					*Accel;
		QFrame					*MainFrame;
		QLabel					*whiteTimeLabel;
		QLabel					*blackTimeLabel;
		QLabel					*Message;
		settingsBase		*SettingsBase;
		core						*Core;
		#ifdef CONSOLE
		Console					*console;
		#endif		
//                splash					*SplashScreen;

		int							NotationIndex;		
		bool						InitAll;
		bool						Minimized;
		bool						ResizeFlag;
		int							margin;
                int				xmargin;
                QString					argsFileName;
};

#endif
