/***************************************************************************
                          knightspixcache.h  -  description
                             -------------------
    begin                : Mon Aug 20 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KNIGHTSPIXCACHE_H
#define KNIGHTSPIXCACHE_H

#include <qvaluelist.h>
#include <qpixmap.h>

/**
  *@author Troy Corbin Jr.
  */

typedef struct cacheItem
{
	QString				label;
	QPixmap				item;
	unsigned int	bytes;
	unsigned int	age;
};

typedef QValueList<cacheItem> pixmapList;

class KnightsPixCache
{
		public:
													KnightsPixCache();
													~KnightsPixCache();
		void									clear( void );
		void									setCacheLimit( const unsigned int limit );
		unsigned int					cacheLimit( void );
		void									add( const QString label, const QPixmap& pixmap );
		bool									find( const QString label, QPixmap& pixmap);
					
		private:
		
		pixmapList						list;
		pixmapList::Iterator	IT;
		
		unsigned int					bytesUsed;
		unsigned int					bytesTotal;
		
		void									cleanCache( const unsigned int space );
};

#endif
