/***************************************************************************
                          list_pgn.cpp  -  description
                             -------------------
    begin                : Thu Dec 13 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "list_pgn.h"
#include "resource.h"
//#include <kglobal.h>
#include <qmessagebox.h>
list_pgn::list_pgn(QWidget *parent, const char *name ) : QVBox(parent,name,Qt::WDestructiveClose)
{
	listView = new KListView( this, "listView" );
	listView->addColumn( i18n( "Result" ) );
	listView->addColumn( i18n( "Title" ) );
	listView->addColumn( i18n( "Round" ) );
	listView->addColumn( i18n( "Site" ) );
	listView->addColumn( i18n( "Date" ) );
	listView->setSorting( 1 );
	listView->setAllColumnsShowFocus( TRUE );
	listView->setMultiSelection( FALSE );
	listView->setShowSortIndicator( TRUE );
	//listView->restoreLayout( KGlobal::config(), "PGN_ListView" );
	listView->show();
	connect( listView, SIGNAL( selectionChanged( QListViewItem* ) ), this, SLOT( slot_selected( QListViewItem* ) ) );

	/*
			Showing listView while scanning can mean the difference between
			a 12 second load time and a 40 second load time. dummyView is
			just a placeholder for listView while scanning.
	*/
	dummyView = new KListView( this, "dummyView" );
	dummyView->addColumn( i18n( "Result" ) );
	dummyView->addColumn( i18n( "Title" ) );
	dummyView->addColumn( i18n( "Round" ) );
	dummyView->addColumn( i18n( "Site" ) );
	dummyView->addColumn( i18n( "Date" ) );
	dummyView->hide();

	statusBox = new QHBox( this, "statusBox" );
	//status = new KStatusBar( statusBox, "status" );

//	progress = new KProgress( statusBox, "progress" );
//		progress->setValue( 0 );

	//show();
}
list_pgn::~list_pgn()
{
//	listView->saveLayout( KGlobal::config(), "PGN_ListView" );
}
///////////////////////////////////////
//
//	list_pgn::setURL
//
///////////////////////////////////////
void list_pgn::setURL( QString URL )
{
	fileURL = URL;
	listView->clear();
	setCaption( URL );

	if( tmpPGN.open( URL ) == FALSE )
	{
		//status->message( i18n( QString( "Can not open %1" ).arg( URL ) ) );
		return;
	}
	listView->hide();
	dummyView->show();
	startTimer( 0 );
}
///////////////////////////////////////
//
//	list_pgn::URL
//
///////////////////////////////////////
QString list_pgn::URL( void )
{
	return fileURL;
}
///////////////////////////////////////
//
//	list_pgn::setProgress
//
///////////////////////////////////////
void list_pgn::setProgress( const int num )
{
// 	progress->setValue( num );
// 	if( num == 100 ) progress->setEnabled( FALSE );
// 	else progress->setEnabled( TRUE );
}
///////////////////////////////////////
//
//	list_pgn::slot_selected
//
///////////////////////////////////////
void list_pgn::slot_selected( QListViewItem *item )
{
	//	emit selected( item->text(5).toInt() );
}
///////////////////////////////////////
//
//	list_pgn::timerEvent
//
///////////////////////////////////////
void list_pgn::timerEvent( QTimerEvent *e )
{
	int fileProgress;

	fileProgress = tmpPGN.scan();
	setProgress( fileProgress );
	if( tmpPGN.scannedMatch.Title.isEmpty() )
	{
 		if( listView->childCount() == 1 ) {
 			emit selected( 0 );
//                         //hide();
//                         }
//                       else
                      //show();
		killTimers();
                }
		listView->show();
		dummyView->hide();
	}
	else
	{
 		(void) new QListViewItem( listView,
 															tmpPGN.scannedMatch.Result,
 															tmpPGN.scannedMatch.Title,
 															tmpPGN.scannedMatch.Round,
 															tmpPGN.scannedMatch.Site,
 															tmpPGN.scannedMatch.Date,
 															QString::number(tmpPGN.scannedMatch.pos) );
		//status->message( i18n( QString( "%1 matches found." ).arg( listView->childCount() ) ) );
	}
}
