/***************************************************************************
                          netconcomm.cpp  -  description
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "netconcomm.h"
#include "resource.h"
#include "definitions.h"
#include <qlistview.h>
//#include <kglobal.h>
netconcomm::netconcomm(QWidget* parent, const char *name) : QWidget(parent,name)
{
	seek = FALSE;
	Sought_ListView = new KListView( this );
	Sought_ListView->addColumn( i18n( "Name" ) );
	Sought_ListView->addColumn( i18n( "Rating" ) );
	Sought_ListView->addColumn( i18n( "Match Type" ) );
	Sought_ListView->addColumn( i18n( "Is Rated?" ) );
	Sought_ListView->addColumn( i18n( "Base Time" ) );
	Sought_ListView->addColumn( i18n( "Increment" ) );
	Sought_ListView->setShowSortIndicator( TRUE );
	Sought_ListView->setAllColumnsShowFocus( TRUE );
	Sought_ListView->setMultiSelection( FALSE );
	//Sought_ListView->restoreLayout( KGlobal::config(), "Sought_ListView" );
}
netconcomm::~netconcomm()
{
}
///////////////////////////////////////
//
//	netconcomm::privateSrc
//
///////////////////////////////////////
 QString netconcomm::privateSrc( void )
{
	return Last_Private_Src;
}
///////////////////////////////////////
//
//	netconcomm::channelSrc
//
///////////////////////////////////////
 QString netconcomm::channelSrc( void )
{
	return Last_Channel_Src;
}
///////////////////////////////////////
//
//	netconcomm::seeking
//
///////////////////////////////////////
 bool netconcomm::seeking( void )
{
	return seek;
}
///////////////////////////////////////
//
//	netconcomm::setPrivateSrc
//
///////////////////////////////////////
 void	netconcomm::setPrivateSrc( const QString &src )
{
	Last_Private_Src = src;
}
///////////////////////////////////////
//
//	netconcomm::setChannelSrc
//
///////////////////////////////////////
 void	netconcomm::setChannelSrc( const QString &src )
{
	Last_Channel_Src = src;
}
///////////////////////////////////////
//
//	netconcomm::setNewMatch
//
///////////////////////////////////////
 void	netconcomm::setNewMatch( const QString &src )
{
	emit newMatch(src);
}
///////////////////////////////////////
//
//	netconcomm::setMessage
//
///////////////////////////////////////
 void	netconcomm::setMessage( const QString &msg )
{
	emit print(msg);
}
///////////////////////////////////////
//
//	netconcomm::setSeeking
//
///////////////////////////////////////
void	netconcomm::setSeeking( const bool src )
{
	seek = src;
	if( seek == FALSE ) Sought_ListView->clear();
}
///////////////////////////////////////
//
//	netconcomm::updateSoughtList
//
///////////////////////////////////////
void	netconcomm::updateSoughtList( void )
{
	unsigned int loop;

	Sought_ListView->clear();
	for( loop = 0; loop < SF_01.count(); loop++ )
	{
		(void) new QListViewItem( Sought_ListView,
															SF_01[loop],
															SF_02[loop],
															SF_03[loop],
															SF_04[loop],
															SF_05[loop],
															SF_06[loop],
															SF_07[loop] );
	}
	SF_01.clear();
	SF_02.clear();
	SF_03.clear();
	SF_04.clear();
	SF_05.clear();
	SF_06.clear();
	SF_07.clear();
}
///////////////////////////////////////
//
//	netconcomm::addSoughtItem
//
///////////////////////////////////////
void	netconcomm::addSoughtItem( const QString &src )
{
	QStringList fields;

	fields = QStringList::split( QChar(' '), src, FALSE );
	SF_01 << fields[2];
	SF_02 << fields[1];
	SF_03 << fields[6];
	SF_04 << fields[5];
	SF_05 << QString( fields[3] + i18n(" min.") );
	SF_06 << QString( fields[4] + i18n(" sec.") );
	SF_07 << fields[0];
}

