/***************************************************************************
                          netconcomm.h  -  description
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NETCONCOMM_H
#define NETCONCOMM_H

#include <klistview.h>
#include <qwidget.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qvaluelist.h>

/**
  *@author Troy Corbin Jr.
  */

typedef struct playerinfo
{
		QString		Raw;
		QString		Name;
		int				Rating;
		bool			Unregistered;
		bool			SysAdmin;
		bool			ServiceRep;
		bool			Computer;
};

typedef QValueList<playerinfo> playerList;

class netconcomm : public QWidget
{
  Q_OBJECT
	public:
											netconcomm(QWidget* parent=0, const char *name=0);
											~netconcomm();

		QString						privateSrc( void );
		QString						channelSrc( void );
		bool							seeking( void );

		void							setPrivateSrc( const QString& );
		void							setChannelSrc( const QString& );
		void							setNewMatch( const QString& );
		void							setMessage( const QString& );
		void							setSeeking( const bool );

		void							addSoughtItem( const QString& );
		void							updateSoughtList( void );

		KListView					*Sought_ListView;

	signals:
		void							newMatch( const QString& );
		void							print( const QString& MSG );
	private:

		QString						Last_Private_Src;
		QString						Last_Channel_Src;
		QStringList				Sought_Game_Numbers;
		bool							seek;

		/*
				These StringLists temporarily store Sought Game data
				until all ads have been displayed.
		*/
		QStringList				SF_01;
		QStringList				SF_02;
		QStringList				SF_03;
		QStringList				SF_04;
		QStringList				SF_05;
		QStringList				SF_06;
		QStringList				SF_07;
};

#endif
