/***************************************************************************
                          resource.cpp  -  description
                             -------------------
    begin                : Tue Jul 17 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* KDE */
//#include <kglobalsettings.h>
#include <ksimpleconfig.h>
#include <kiconloader.h>
#include <kconfig.h>
//#include <kglobal.h>
#include <kiconloader.h>
//#include <kio/netaccess.h>
/* Local */
#include "resource.h"
/* C & C++ */
#include <unistd.h>
#include <sys/utsname.h>
#include <sys/types.h>
#include <pwd.h>
#include <time.h>
#include <qpe/qpeapplication.h>
#include <qpe/config.h>
//#define CFG/KGlobal::config()
///////////////////////////////////////
//
//	resource::resource
//
///////////////////////////////////////
resource::resource()
{

	Widget_Height = 20; // prevents max_size error for thinbuttons on init
	Icons = new KIconLoader();
	//Audio = new audio();
	CFG = new KConfig(QDir::homeDirPath() + "/Settings/" + "knights.conf" );
	/* Define ConsoleStyle, our RichText */
	ConsoleStyle = new QStyleSheet( 0, "ConsoleStyle" );
	SSI_Default = new QStyleSheetItem( ConsoleStyle, "K_STD" );
	SSI_PrivateTell = new QStyleSheetItem( ConsoleStyle, "K_PVT" );
	SSI_ChannelTell = new QStyleSheetItem( ConsoleStyle, "K_CH" );
	SSI_Shout = new QStyleSheetItem( ConsoleStyle, "K_SHT" );
	SSI_Whisper = new QStyleSheetItem( ConsoleStyle, "K_WSP" );
	SSI_Notification = new QStyleSheetItem( ConsoleStyle, "K_NOT" );
	QStyleSheet::setDefaultSheet( ConsoleStyle );

	/* Define GlobalDataDir... This is very important! */
	//GlobalDataDir = args->getOption( "d" );
		GlobalDataDir = "";
//FIXME
//         if( GlobalDataDir.isEmpty() )
// 		GlobalDataDir = KGlobal::dirs()->findResourceDir("data", "knights/splash.png") + "knights/";
// 	if( GlobalDataDir.isEmpty() )
// 			kdDebug() << "resource::resource: Can not read GlobalDataDir from environment." << endl;
// 	if( GlobalDataDir.right(1) != "/" ) GlobalDataDir += '/';

	ConfigRead();
	pixCache = new KnightsPixCache();
	pixCache->setCacheLimit( 2048 ); // 2meg
}
///////////////////////////////////////
//
//	resource::~resource
//
///////////////////////////////////////
resource::~resource()
{
	ConfigWrite();
	delete Icons;
	delete pixCache;
//	delete Audio;
}
///////////////////////////////////////
//
//	resource::ConfigRead
//
///////////////////////////////////////
void resource::ConfigRead( void )
{
kdDebug() << "resource::ConfigRead" << endl;
  struct passwd *passwd;
	QSize tempSize( 384, 384 );
	QPoint tempPoint( 0, 0 );
  QString sysName;
	QString buffer;

	/* Get user name from environment in case it's needed */
  passwd = getpwuid( getuid() );
  sysName = passwd->pw_gecos;
  if( sysName.isEmpty() ) sysName = passwd->pw_name;
	/* Themes */
	readThemeDir();
	CFG->setGroup( "Themes" );
        //FIXME - put isEmpty checks around
	//CurrentBoard = CFG->readEntry( "CurrentBoard", "KBDefault.tar.gz );
        CurrentBoard = CFG->readEntry( "CurrentBoard", "KBDefault" );
        kdDebug() << "resource::ConfigRead, CurrentBoard: " << CurrentBoard << endl;
        //CurrentChessmen = CFG->readEntry( "CurrentChessmen", "KCDefault.tar.gz" );
        CurrentChessmen = CFG->readEntry( "CurrentChessmen", "KCXBoard" );
        kdDebug() << "resource::ConfigRead, CurrentChessmen: " << CurrentChessmen << endl;
	ThemeSize = CFG->readNumEntry( "Size", 27);
	OPTION_3DBoard = CFG->readBoolEntry( "Use3DBoard", FALSE );

	CFG->setGroup("General");
        currentEngineName = CFG->readEntry("CurrentEngineName",QString("Phalanx"));
        kdDebug() << "Current Engine Name from config " << currentEngineName << endl;	
	/* General */
	ReadEngines();
	ReadServers();
	ReadTCP();
	ReadColors();
	ReadFonts();
	buildStyle();
	CFG->setGroup( "General" );
	Local_Player = CFG->readEntry( "UserName", "Player" );
	Config_Version = CFG->readNumEntry( "ConfigVersion", 0 );
	OPTION_On_Init = CFG->readNumEntry( "OnInit", MENU_VS_PC );
        kdDebug() << "OPTION_On_Init" << OPTION_On_Init << endl;
	OPTION_Show_Splash = CFG->readBoolEntry( "ShowSplash", TRUE );
	OPTION_Auto_Queen = CFG->readBoolEntry( "AlwaysQueen", FALSE );
	OPTION_Play_Black = CFG->readBoolEntry( "PlayBlack", FALSE );
	OPTION_Auto_Preview = CFG->readBoolEntry( "AutoPreview", true );
	OPTION_Show_Last_Move = CFG->readBoolEntry( "ShowLastMove", true );
	OPTION_Show_Coord = CFG->readBoolEntry( "ShowCoord", FALSE );
	OPTION_Ponder = CFG->readBoolEntry( "Ponder", TRUE );
	OPTION_Book_White = CFG->readBoolEntry( "BookWhite", FALSE );
	OPTION_Book_Black = CFG->readBoolEntry( "BookBlack", FALSE );
	OPTION_Board_Orientation = CFG->readBoolEntry( "BoardOrientation", 0 );
	OPTION_High_Quality = CFG->readBoolEntry( "HighQuality", TRUE );
	OPTION_Pause_On_Minimize = CFG->readBoolEntry( "PauseOnMinimize", FALSE );
	OPTION_Reuse_PGN = CFG->readBoolEntry( "ReusePGN", FALSE );
	PGN_Filename = CFG->readEntry( "PGNFilename", QString::null );
	OPTION_Auto_Close_Last_ICS = CFG->readBoolEntry( "AutoCloseLastICS", TRUE );
	OPTION_Show_Extended_PGN = CFG->readEntry( "ShowExtendedPGN", FALSE );
	OPTION_Auto_Call_Flag = CFG->readBoolEntry( "AutoCallFlag", TRUE );
	Email_Command_Line = CFG->readEntry( "EmailCommandLine", QString("kmail -s %s --attach %m %a") );
        difficulty = CFG->readEntry("Difficulty","moderate");
		/* ICS */
	CFG->setGroup( "ICS" );
	OPTION_Premove = CFG->readBoolEntry( "Premove", TRUE );
	OPTION_Kibitz = CFG->readBoolEntry( "Kibitz", TRUE );
	OPTION_Private = CFG->readBoolEntry( "Private", FALSE );
	OPTION_Shout = CFG->readBoolEntry( "Shout", TRUE );
	OPTION_Tell = CFG->readBoolEntry( "Tell", TRUE );
	OPTION_Seek = CFG->readBoolEntry( "Seek", TRUE );
	OPTION_Profanity = CFG->readNumEntry( "Profanity", 1 );
	Seek_Timer = CFG->readNumEntry( "SeekTimer", 70 );

	/* Audio */
// 	CFG->setGroup( "Audio" );
// 	OPTION_Audio = CFG->readBoolEntry( "useAudio", TRUE );
// 	CurrentAudio = CFG->readEntry( "currentAudio", "KSDefault.tar.gz" );
// 	OPTION_Audio_Current_Only = CFG->readBoolEntry( "AudioCurrentOnly", FALSE );
// 	Audio_Volume = CFG->readNumEntry( "AudioVolume", 100 );
// 	Audio->enabled = OPTION_Audio;
// 	Audio->volume = Audio_Volume;

	/* Console Attributes */
	CFG->setGroup( "Console" );
	OPTION_Console_Attach = CFG->readBoolEntry( "ConsoleAttach", FALSE );
	OPTION_Console_Orientation = CFG->readNumEntry( "ConsoleOrientation", 1 );
	Console_Detached = CFG->readSizeEntry( "ConsoleDetached", &tempSize );
	Console_Right = CFG->readSizeEntry( "ConsoleRight", &tempSize );
	Console_Bottom = CFG->readSizeEntry( "ConsoleBottom", &tempSize );
	Console_Detached_Loc = CFG->readPointEntry( "ConsoleDetachedLoc", &tempPoint );
	Console_Splitter_1 = CFG->readNumEntry( "ConsoleSplitter1", 192 );
	Console_Splitter_2 = CFG->readNumEntry( "ConsoleSplitter2", 192 );

	/* Notification Prompts */
	CFG->setGroup( "Notification Messages" );
	PromptForSaving = CFG->readEntry( "PromptForSaving", QString::null );
        kdDebug() << "Prompt for Saving: " << PromptForSaving << endl;
}
///////////////////////////////////////
//
//	resource::ConfigWrite
//
///////////////////////////////////////
void resource::ConfigWrite( void )
{
	/* Themes */
	CFG->setGroup( "Themes" );
	CFG->writeEntry( "CurrentBoard", CurrentBoard );
	CFG->writeEntry( "CurrentChessmen", CurrentChessmen );
	CFG->writeEntry( "Size", ThemeSize );
	CFG->writeEntry( "Use3DBoard", OPTION_3DBoard );

	/* General */
	WriteEngines();
	WriteServers();
	WriteTCP();
	WriteColors();
	WriteFonts();
	CFG->setGroup( "General" );
	CFG->writeEntry( "UserName", Local_Player );
	CFG->writeEntry( "ConfigVersion", Config_Version );
	CFG->writeEntry( "OnInit", OPTION_On_Init );
	CFG->writeEntry( "ShowSplash", OPTION_Show_Splash );
	CFG->writeEntry( "AlwaysQueen", OPTION_Auto_Queen );
	CFG->writeEntry( "PlayBlack", OPTION_Play_Black );
	CFG->writeEntry( "AutoPreview", OPTION_Auto_Preview );
	CFG->writeEntry( "ShowLastMove", OPTION_Show_Last_Move );
	CFG->writeEntry( "ShowCoord", OPTION_Show_Coord );
	CFG->writeEntry( "Ponder", OPTION_Ponder );
	CFG->writeEntry( "BookWhite", OPTION_Book_White );
	CFG->writeEntry( "BookBlack", OPTION_Book_Black );
	CFG->writeEntry( "BoardOrientation", OPTION_Board_Orientation );
	CFG->writeEntry( "HighQuality", OPTION_High_Quality );
	CFG->writeEntry( "PauseOnMinimize", OPTION_Pause_On_Minimize );
	CFG->writeEntry( "ReusePGN", OPTION_Reuse_PGN );
	CFG->writeEntry( "PGNFilename", PGN_Filename );
	CFG->writeEntry( "AutoCloseLastICS", OPTION_Auto_Close_Last_ICS );
	CFG->writeEntry( "ShowExtendedPGN", OPTION_Show_Extended_PGN );
	CFG->writeEntry( "EmailCommandLine", Email_Command_Line );
	CFG->writeEntry( "AutoCallFlag", OPTION_Auto_Call_Flag );
        CFG->writeEntry( "CurrentEngineName",currentEngineName);
        CFG->writeEntry( "Difficulty",difficulty);
	/* ICS */
	CFG->setGroup( "ICS" );
	CFG->writeEntry( "SeekTimer", Seek_Timer );
	CFG->writeEntry( "Profanity", OPTION_Profanity );
	CFG->writeEntry( "Premove", OPTION_Premove );
	CFG->writeEntry( "Shout", OPTION_Shout );
	CFG->writeEntry( "Kibitz", OPTION_Kibitz );
	CFG->writeEntry( "Private", OPTION_Private );
	CFG->writeEntry( "Tell", OPTION_Tell );
	CFG->writeEntry( "Seek", OPTION_Seek );

	/* Audio */
// 	CFG->setGroup( "Audio" );
// 	CFG->writeEntry( "useAudio", OPTION_Audio );
// 	Audio->enabled = OPTION_Audio;
// 	CFG->writeEntry( "CurrentAudio", CurrentAudio );
// 	CFG->writeEntry( "AudioCurrentOnly", OPTION_Audio_Current_Only );
// 	CFG->writeEntry( "AudioVolume", Audio_Volume );
// 	Audio->volume = Audio_Volume;

	/* Console Attributes */
	CFG->setGroup( "Console" );
	CFG->writeEntry( "ConsoleAttach", OPTION_Console_Attach );
	CFG->writeEntry( "ConsoleOrientation", OPTION_Console_Orientation );
	CFG->writeEntry( "ConsoleDetached", Console_Detached );
	CFG->writeEntry( "ConsoleRight", Console_Right );
	CFG->writeEntry( "ConsoleBottom", Console_Bottom );
	CFG->writeEntry( "ConsoleDetachedLoc", Console_Detached_Loc );
	CFG->writeEntry( "ConsoleSplitter1", Console_Splitter_1 );
	CFG->writeEntry( "ConsoleSplitter2", Console_Splitter_2 );

	/* Notification Prompts */
	CFG->setGroup( "Notification Messages" );
	CFG->writeEntry( "PromptForSaving", PromptForSaving );
	CFG->sync();
}
///////////////////////////////////////
//
//	resource::ReadTCP
//
///////////////////////////////////////
void resource::ReadTCP( void )
{
	QString buffer;
	QStringList TCPs;
	QStringList::Iterator QSL_IT;
	TCP tempTCP;

	TCPWhite.clear();
	TCPBlack.clear();
	CFG->setGroup( "Time Control" );

	buffer = CFG->readEntry( "White", "40,300,0" );
	TCPs = QStringList::split( QString(","), buffer, FALSE );
	for( QSL_IT = TCPs.begin(); QSL_IT != TCPs.end(); ++QSL_IT )
	{
		tempTCP.Moves = (*QSL_IT).toInt();
		++QSL_IT;
		tempTCP.Seconds = (*QSL_IT).toInt();
		++QSL_IT;
		tempTCP.Increment = (*QSL_IT).toInt();
		TCPWhite.append( tempTCP );
	}
	TCPs.clear();
	buffer = CFG->readEntry( "Black", "40,300,0" );
	TCPs = QStringList::split( QString(","), buffer, FALSE );
	for( QSL_IT = TCPs.begin(); QSL_IT != TCPs.end(); ++QSL_IT )
	{
		tempTCP.Moves = (*QSL_IT).toInt();
		++QSL_IT;
		tempTCP.Seconds = (*QSL_IT).toInt();
		++QSL_IT;
		tempTCP.Increment = (*QSL_IT).toInt();
		TCPBlack.append( tempTCP );
	}
}
///////////////////////////////////////
//
//	resource::WriteTCP
//
///////////////////////////////////////
void resource::WriteTCP( void )
{
	QString buffer;
	TCPList::Iterator TCP_IT;

	CFG->setGroup( "Time Control" );
	for( TCP_IT = TCPWhite.begin(); TCP_IT != TCPWhite.end(); ++TCP_IT )
	{
		buffer += QString::number( (*TCP_IT).Moves ) + ",";
		buffer += QString::number( (*TCP_IT).Seconds ) + ",";
		buffer += QString::number( (*TCP_IT).Increment ) + ",";
	}
	CFG->writeEntry( "White", buffer );
	buffer = "";
	for( TCP_IT = TCPBlack.begin(); TCP_IT != TCPBlack.end(); ++TCP_IT )
	{
		buffer += QString::number( (*TCP_IT).Moves ) + ",";
		buffer += QString::number( (*TCP_IT).Seconds ) + ",";
		buffer += QString::number( (*TCP_IT).Increment ) + ",";
	}
	CFG->writeEntry( "Black", buffer );
}
///////////////////////////////////////
//
//	resource::ReadEngines
//
///////////////////////////////////////
void resource::ReadEngines( void )
{
kdDebug() << "resource::ReadEngines" << endl;
// QString buffer = currentEngineName;
// if (currentEngineName.isEmpty()) {
//   CFG->setGroup("General");
//  currentEngineName = CFG->readEntry("CurrentEngineName","GnuChess");
//  }
kdDebug() << "engine name " << currentEngineName << endl;	
QFile file(QPEApplication::qpeDir()+"/chess/engines/"+currentEngineName+"/capabilities");
if (file.exists())
{
Config tmpConfig(QPEApplication::qpeDir()+"chess/engines/"+currentEngineName+"/capabilities",Config::File);
tmpConfig.setGroup("GENERAL");
currentEngine.Name=currentEngineName;

currentEngine.Filename=QPEApplication::qpeDir()+"chess/engines/"+currentEngineName+"/"+tmpConfig.readEntry("exec");
kdDebug() << "FileName: " << currentEngine.Filename << endl;
currentEngine.Arguments=tmpConfig.readEntry("cmd");
currentEngine.Protocol = XBoard;
currentEngine.Wins = 0;
currentEngine.Losses = 0;
currentEngine.Draws = 0;
tmpConfig.setGroup("CAPABILITIES");
if (tmpConfig.readEntry("HINT")=="1") 
    currentEngine.Hint = true;
if (tmpConfig.readEntry("UNDO")=="1")
    currentEngine.Undo = true;
if (tmpConfig.readEntry("BOOK")=="1") 
    currentEngine.Book = true;

tmpConfig.setGroup("DIFFICULTY");

currentEngine.very_easy_args = tmpConfig.readEntry("level_very_easy_cmd");
kdDebug() << "very_easy_args: " << currentEngine.very_easy_args << endl;

currentEngine.easy_args = tmpConfig.readEntry("level_easy_cmd");
kdDebug() << "easy_args: " << currentEngine.easy_args << endl;

currentEngine.moderate_args = tmpConfig.readEntry("level_moderate_cmd");
kdDebug() << "moderate_args: " << currentEngine.moderate_args << endl;

currentEngine.hard_args = tmpConfig.readEntry("level_hard_cmd");
kdDebug() << "hard_args: " << currentEngine.hard_args << endl;

currentEngine.very_hard_args = tmpConfig.readEntry("level_very_hard_cmd");
kdDebug() << "very_hard_args: " << currentEngine.very_hard_args << endl;


}
// 	engineResource temp;
// 	QStringList engineList;
// 	QStringList::Iterator engineListIT;
// 	QString buffer;
// 
// 	engines.clear();
// 	CFG->setGroup( "General" );
// 	buffer = CFG->readEntry( "Engines" );
// 	if( buffer.isEmpty() ) return;
// 
// 	engineList = QStringList::split( QString(","), buffer, FALSE );
// 	for ( engineListIT = engineList.begin(); engineListIT != engineList.end(); ++engineListIT )
// 	{
//         	kdDebug() << "EngineListIT loop" << endl << *engineListIT;
// //		if( !CFG->hasGroup( (*engineListIT) ) ) continue;
// 		CFG->setGroup( (*engineListIT) );
// 		temp.Name = (*engineListIT);
// 		temp.Filename = CFG->readEntry( "Filename" );
//                 kdDebug() << "FileName: " << CFG->readEntry( "Filename" );
// 		temp.Arguments = CFG->readEntry( "Arguments" );
// 		temp.LogFile = CFG->readEntry( "Log" );
// 		temp.Protocol = CFG->readNumEntry( "Protocol" );
// 		temp.Wins = CFG->readNumEntry( "Wins" );
// 		temp.Losses = CFG->readNumEntry( "Losses" );
// 		temp.Draws = CFG->readNumEntry( "Draws" );
// 		temp.CurrentRef = CFG->readNumEntry( "CurrentRef" );
// 		/* This updates 0.4.5 & 0.4.4 configs to the new Protocol config */
// 		if( ( temp.Protocol != XBoard ) && ( temp.Protocol != Knights1 ) ) temp.Protocol = XBoard;
// 		engines.append( temp );
// 	}
}
///////////////////////////////////////
//
//	resource::WriteEngines
//
///////////////////////////////////////
void resource::WriteEngines( void )
{
	QString buffer;

	CFG->setGroup( "General" );
	if( engines.isEmpty() )
	{
		CFG->writeEntry( "Engines", QString( "" ) );
		return;
	}
	for ( enginesIT = engines.begin(); enginesIT != engines.end(); ++enginesIT )
	{
		buffer += (*enginesIT).Name + ",";
		CFG->setGroup( (*enginesIT).Name );
		CFG->writeEntry( "Filename", (*enginesIT).Filename );
		CFG->writeEntry( "Arguments", (*enginesIT).Arguments );
		CFG->writeEntry( "Log", (*enginesIT).LogFile );
		CFG->writeEntry( "Protocol", (*enginesIT).Protocol );
		CFG->writeEntry( "Wins", (*enginesIT).Wins );
		CFG->writeEntry( "Losses", (*enginesIT).Losses );
		CFG->writeEntry( "Draws", (*enginesIT).Draws );
		CFG->writeEntry( "CurrentRef", (*enginesIT).CurrentRef );
	}
	CFG->setGroup( "General" );
	CFG->writeEntry( "Engines", buffer );
	CFG->sync();
}
///////////////////////////////////////
//
//	resource::ReadServers
//
///////////////////////////////////////
void resource::ReadServers( void )
{
	serverResource temp;
	QStringList serverList;
	QStringList::Iterator serverListIT;
	QString buffer;

	servers.clear();
	CFG->setGroup( "General" );
	buffer = CFG->readEntry( "Servers" );
	if( buffer.isEmpty() ) return;

	serverList = QStringList::split( QString(","), buffer, FALSE );
	for ( serverListIT = serverList.begin(); serverListIT != serverList.end(); ++serverListIT )
	{
//		if( !CFG->hasGroup( (*serverListIT) ) ) continue;
		CFG->setGroup( (*serverListIT) );
		temp.Name = (*serverListIT);
		temp.URL = CFG->readEntry( "URL" );
		temp.UserName = CFG->readEntry( "UserName" );
		temp.LogFile = CFG->readEntry( "LogFile" );
		temp.Password = decryptStr( CFG->readEntry( "Password" ) );
		temp.StorePass = CFG->readBoolEntry( "StorePass" );
		temp.Port = CFG->readNumEntry( "Port" );
		temp.CurrentRef = CFG->readNumEntry( "CurrentRef" );
		temp.Timeseal = CFG->readEntry( "Timeseal" );
		servers.append( temp );
	}
}
///////////////////////////////////////
//
//	resource::WriteServers
//
///////////////////////////////////////
void resource::WriteServers( void )
{
	QString buffer;

	CFG->setGroup( "General" );
	if( servers.isEmpty() )
	{
		CFG->writeEntry( "Servers", QString( "" ) );
		return;
	}
	for ( serversIT = servers.begin(); serversIT != servers.end(); ++serversIT )
	{
		buffer += (*serversIT).Name + ",";
		CFG->setGroup( (*serversIT).Name );
		CFG->writeEntry( "URL", (*serversIT).URL );
		CFG->writeEntry( "UserName", (*serversIT).UserName );
		CFG->writeEntry( "LogFile", (*serversIT).LogFile );
		if( (*serversIT).StorePass )
			CFG->writeEntry( "Password", encryptStr( (*serversIT).Password ) );
		else
			CFG->writeEntry( "Password", "" );
		CFG->writeEntry( "Port", (*serversIT).Port );
		CFG->writeEntry( "StorePass", (*serversIT).StorePass );
		CFG->writeEntry( "CurrentRef", (*serversIT).CurrentRef );
		CFG->writeEntry( "Timeseal", (*serversIT).Timeseal );
	}
	CFG->setGroup( "General" );
	CFG->writeEntry( "Servers", buffer );
	CFG->sync();
}
///////////////////////////////////////
//
//	resource::themeDir
//
///////////////////////////////////////
QString resource::themeDir( void )
{
	return QString( QPEApplication::qpeDir() + "pics/knights/themes/" );
}
///////////////////////////////////////
//
//	resource::readThemeDir
//
///////////////////////////////////////
void resource::readThemeDir( void )
{
	QDir themesDir;
	
	Boards.clear();
	Chessmen.clear();
	Sounds.clear();
	
	themesDir.setNameFilter( "KB*" );
	//themesDir = GlobalDataDir + "themes/";
        themesDir = themeDir();
	Boards += themesDir.entryList();
// 	themesDir = QDir::homeDirPath() + "/.knights/";
// 	if( themesDir.exists() ) Boards += themesDir.entryList();
// 	themesDir = "../media/";
// 	if( themesDir.exists() ) Boards += themesDir.entryList();
	kdDebug() << "Boards " << Boards.count() << endl;
        
	Boards.sort();
	
	themesDir.setNameFilter( "KC*" );
	//themesDir = GlobalDataDir + "themes/";
	themesDir = themeDir();
        Chessmen += themesDir.entryList();
        Chessmen.sort();
        kdDebug() << "Chessmen " << Chessmen.count() << endl;
// 	themesDir = QDir::homeDirPath() + "/.knights/";
// 	if( themesDir.exists() ) Chessmen += themesDir.entryList();
// 	themesDir = "../media/";
// 	if( themesDir.exists() ) Chessmen += themesDir.entryList();
	

// 	themesDir.setNameFilter( "KS*" );
// 	themesDir = GlobalDataDir + "themes/";
// 	Sounds += themesDir.entryList();
// 	themesDir = QDir::homeDirPath() + "/.knights/";
// 	if( themesDir.exists() ) Sounds += themesDir.entryList();
// 	themesDir = "../media/";
// 	if( themesDir.exists() ) Sounds += themesDir.entryList();
// 	Sounds.sort();
}
///////////////////////////////////////
//
//	resource::getBoard
//
///////////////////////////////////////
QString resource::getBoard( int Index )
{
	kdDebug() << "resource::getBoard" << endl;
	if( Index > (signed)Boards.count() ) return QString::null;
	if( Index == -1 ) return CurrentBoard;
	return  Boards[Index];
}
///////////////////////////////////////
//
//	resource::getChessmen
//
///////////////////////////////////////
QString resource::getChessmen( int Index )
{
	if( Index > (signed)Chessmen.count() ) return QString::null;
	if( Index == -1 ) return CurrentChessmen;
	return  Chessmen[Index];
}
///////////////////////////////////////
//
//	resource::getSounds
//
///////////////////////////////////////
QString resource::getSounds( int Index )
{
	if( Index > (signed)Sounds.count() ) return QString::null;
	if( Index == -1 ) return CurrentAudio;
	return Sounds[Index];
}
///////////////////////////////////////
//
//	resource::setAudio
//
///////////////////////////////////////
void resource::setAudio( int AudioIndex )
{
	QString audioURL;
	
	/* Make sure the Indexes are valid */
	if( AudioIndex > (signed)Sounds.count() )
	{
		kdDebug() << "Can not access audio theme[" << AudioIndex << "]... Index out of range." << endl;
		return;
	}
	/* Change the theme */
	if( AudioIndex != -1 ) CurrentAudio = Sounds[AudioIndex];
	audioURL = themeURL( CurrentAudio );
	if( audioURL.isEmpty() ) return;
//	Audio->setTheme( audioURL );
	return;
}
///////////////////////////////////////
//
//	resource::setTheme
//
///////////////////////////////////////
void resource::setTheme( int BoardIndex, int ChessmenIndex )
{
kdDebug() << "resource::setTheme" << endl;
kdDebug() << "BoardIndex" << BoardIndex << endl;
kdDebug() << "ChessmenIndex" << ChessmenIndex << endl;
	static bool firstTime( TRUE );
	static bool prevHQ( OPTION_High_Quality );
	QString boardURL;
	QString chessmenURL;
	QString boardConf;
	QString chessmenConf;
	KConfig *boardConfig;
	KConfig *chessmenConfig;
	
	/* Make sure the Indexes are valid */
	if( BoardIndex > (signed)Boards.count() )
	{
		kdDebug() << "Can not access board theme[" << BoardIndex << "]... Index out of range." << endl;
		return;
	}
	if( ChessmenIndex > (signed)Chessmen.count() )
	{
		kdDebug() << "Can not access chessmen theme[" << ChessmenIndex << "]... Index out of range." << endl;
		return;
	}
	/* If you're only resizing, and you're in High Quality mode, we can just
			flush the cache and be done. No need to reload. */
// 	if( !firstTime )
// 		if( ( BoardIndex == -1 ) && ( ChessmenIndex == -1 ) )
// 			if( ( prevHQ == OPTION_High_Quality ) && ( prevHQ == TRUE ) )
// 			{
// 				pixCache->clear();
// 				return;
// 			}
	/* Change the theme */
	if( BoardIndex != -1 ) CurrentBoard = Boards[BoardIndex];
	if( ChessmenIndex != -1 ) CurrentChessmen = Chessmen[ChessmenIndex];
        kdDebug() << "Current board " << CurrentBoard << endl;
        
	boardURL = themeURL( CurrentBoard );
        if ( boardURL.isEmpty() )
           kdDebug() << "Board url is empty!" << endl;
	if( boardURL.isEmpty() ) return;
        kdDebug() << "Current chesmen " << CurrentChessmen << endl;
        chessmenURL = themeURL( CurrentChessmen );
        if( chessmenURL.isEmpty() ) return;
	/* load the theme.conf files */
/*	if( !KIO::NetAccess::download( boardURL + "theme.conf", boardConf ) )
		kdWarning() << "Can not read theme.conf from " << boardURL << endl;*/
	boardConfig = new KConfig( boardURL + "theme.conf" );
// 	if( !KIO::NetAccess::download( chessmenURL + "theme.conf", chessmenConf ) )
// 		kdWarning() << "Can not read theme.conf from " << chessmenURL << endl;
	chessmenConfig = new KConfig( chessmenURL + "theme.conf" );
	/* Read the headers */
	
	boardHeader.name = boardConfig->readEntry( "Name", "Unknown" );
	boardHeader.version = boardConfig->readEntry( "Version", "Unknown" );
	boardHeader.author = boardConfig->readEntry( "Author", "Unknown" );
	boardHeader.authorEmail = boardConfig->readEntry( "AuthorEmail", "Unknown" );
	boardHeader.authorWWW = boardConfig->readEntry( "AuthorWWW", "Unknown" );
	boardHeader.notes = boardConfig->readEntry( "Notes", "Unknown" );
	
	chessmenHeader.name = chessmenConfig->readEntry( "Name", "Unknown" );
	chessmenHeader.version = chessmenConfig->readEntry( "Version", "Unknown" );
	chessmenHeader.author = chessmenConfig->readEntry( "Author", "Unknown" );
	chessmenHeader.authorEmail = chessmenConfig->readEntry( "AuthorEmail", "Unknown" );
	chessmenHeader.authorWWW = chessmenConfig->readEntry( "AuthorWWW", "Unknown" );
	chessmenHeader.notes = chessmenConfig->readEntry( "Notes", "Unknown" );
	/* Load the themes */
	loadThemeItem( boardURL + boardConfig->readEntry("BoardLight", "square.light.png"), SquareLight );
        
	loadThemeItem( boardURL + boardConfig->readEntry("BoardDark", "square.dark.png"), SquareDark );
	loadThemeItem( boardURL + boardConfig->readEntry("BoardSelect", "square.select.png"), HighlightSelect );
	loadThemeItem( boardURL + boardConfig->readEntry("BoardMotion", "square.motion.png"), HighlightMove );
	loadThemeItem( boardURL + boardConfig->readEntry("BoardDanger", "square.danger.png"), HighlightAttack );
	
	COLOR_Notation = boardConfig->readColorEntry( "TextColor", &COLOR_White );
	COLOR_Notation_Shadow = boardConfig->readColorEntry( "ShadowColor", &COLOR_Black );
	kdDebug() << "reading BlackKing: " << chessmenConfig->readEntry("BlackKing") << endl;
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackKing", "black.king.png"), BlackKing );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackQueen", "black.queen.png"), BlackQueen );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackBishop", "black.bishop.png"), BlackBishop );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackKnight", "black.knight.png"), BlackKnight );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackRook", "black.rook.png"), BlackRook );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("BlackPawn", "black.pawn.png"), BlackPawn );
	
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhiteKing", "white.king.png"), WhiteKing );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhiteQueen", "white.queen.png"), WhiteQueen );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhiteBishop", "white.bishop.png"), WhiteBishop );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhiteKnight", "white.knight.png"), WhiteKnight );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhiteRook", "white.rook.png"), WhiteRook );
	loadThemeItem( chessmenURL + chessmenConfig->readEntry("WhitePawn", "white.pawn.png"), WhitePawn );
	/* Remove the theme.conf files */
	delete boardConfig;
	delete chessmenConfig;

	/* Cleanup */
	pixCache->clear();
	prevHQ = OPTION_High_Quality;
	firstTime = FALSE;
	return;
}
///////////////////////////////////////
//
//	resource::loadThemeItem
//
///////////////////////////////////////
void resource::loadThemeItem( const QString &URL, QPixmap &Pixmap )
{
kdDebug() << "resource:: load theme item : " << URL << endl;
	QImage tempImage;
	QString tempFile;
	int tempSize;
	
	if( OPTION_High_Quality ) tempSize = IMAGE_MAX;
	else tempSize = ThemeSize;
//	if( KIO::NetAccess::download( URL, tempFile ) )
//	{
		//if( tempImage.load( URL ) ) {
                        kdDebug() << "loadthemeItem URL = " << URL << endl;
			//Pixmap.convertFromImage( tempImage.smoothScale( tempSize, tempSize ) );
                        if (!Pixmap.load(URL))
                        kdDebug() << "resource::LoadThemeItem: Can not load " << URL << ", which comes from " << URL << endl;

#include <qbitmap.h>
if (Pixmap.mask() == 0L)
	kdDebug() << URL << " has no mask" << endl;

/*                }
		else
			kdDebug() << "resource::LoadThemeItem: Can not load " << URL << ", which comes from " << URL << endl;*/
		//KIO::NetAccess::removeTempFile( tempFile );
	//}
	//else kdDebug() << "resource::LoadThemeItem: Can not extract " << URL << endl;
	return;
}
///////////////////////////////////////
//
//	resource::LoadIcon
//
///////////////////////////////////////
QPixmap resource::LoadIcon( QString Name, int Group )
{
	return Icons->loadIcon( Name, (KIcon::Group)Group );
}
///////////////////////////////////////
//
//	resource::encryptStr
//
///////////////////////////////////////
//	Borrowed from KMail
QString resource::encryptStr(const QString &aStr) const
{
	unsigned int i, val;
	unsigned int len = aStr.length();
	QCString result;
	result.resize(len+1);
	for (i=0; i<len; i++)
	{
		val = aStr[i] - ' ';
		val = (255-' ') - val;
		result[i] = (char)(val + ' ');
	}
	result[i] = '\0';

	return result;
}
///////////////////////////////////////
//
//	resource::decryptStr
//
///////////////////////////////////////
//	Borrowed from KMail
inline QString resource::decryptStr(const QString &aStr) const
{
	return encryptStr(aStr);
}
///////////////////////////////////////
//
//	resource::play
//
///////////////////////////////////////
void resource::play( const char snd )
{
//	Audio->play( snd );
}
///////////////////////////////////////
//
//	resource::ReadColors
//
///////////////////////////////////////
void resource::ReadColors( void )
{
	QColor tmp;
	
	COLOR_White = QColor( 255, 255, 255 );
	COLOR_Black = QColor( 0, 0, 0 );
	CFG->setGroup( "Colors" );
	COLOR_Background = CFG->readColorEntry( "BackgroundColor", &COLOR_White );
	COLOR_Standard = CFG->readColorEntry( "StandardColor", &COLOR_Black );
	tmp = QColor( 128, 0, 128 );	// Purple
	COLOR_PrivateTell = CFG->readColorEntry( "PrivateColor", &tmp );
	tmp = QColor( 0, 0, 160 );	// Blue
	COLOR_ChannelTell = CFG->readColorEntry( "ChannelColor", &tmp );
	tmp = QColor( 160, 0, 0 );	// Red
	COLOR_Shout = CFG->readColorEntry( "ShoutColor", &tmp );
	tmp = QColor( 0, 160, 0 );	// Green
	COLOR_Whisper = CFG->readColorEntry( "WhisperColor", &tmp );
	tmp = QColor( 0, 128, 128 );	// Cyan
	COLOR_Notification = CFG->readColorEntry( "NotificationColor", &tmp );
}
///////////////////////////////////////
//
//	resource::WriteColors
//
///////////////////////////////////////
void resource::WriteColors( void )
{
	CFG->setGroup( "Colors" );
	CFG->writeEntry( "BackgroundColor", COLOR_Background );
	CFG->writeEntry( "StandardColor", COLOR_Standard );
	CFG->writeEntry( "PrivateColor", COLOR_PrivateTell );
	CFG->writeEntry( "ChannelColor", COLOR_ChannelTell );
	CFG->writeEntry( "ShoutColor", COLOR_Shout );
	CFG->writeEntry( "WhisperColor", COLOR_Whisper );
	CFG->writeEntry( "NotificationColor", COLOR_Notification );
}
///////////////////////////////////////
//
//	resource::ReadFonts
//
///////////////////////////////////////
void resource::ReadFonts( void )
{
	QFont Fixed("Fixed");
	CFG->setGroup( "Fonts" );
	FONT_Standard = CFG->readFontEntry( "StandardFont", &Fixed );
	FONT_PrivateTell = CFG->readFontEntry( "PrivateFont", &Fixed );
	FONT_ChannelTell = CFG->readFontEntry( "ChannelFont", &Fixed );
	FONT_Shout = CFG->readFontEntry( "ShoutFont", &Fixed );
	FONT_Whisper = CFG->readFontEntry( "WhisperFont", &Fixed );
	FONT_Notification = CFG->readFontEntry( "NotificationFont", &Fixed );
}
///////////////////////////////////////
//
//	resource::WriteFonts
//
///////////////////////////////////////
void resource::WriteFonts( void )
{
	CFG->setGroup( "Fonts" );
	CFG->writeEntry( "StandardFont", FONT_Standard );
	CFG->writeEntry( "PrivateFont", FONT_PrivateTell );
	CFG->writeEntry( "ChannelFont", FONT_ChannelTell );
	CFG->writeEntry( "ShoutFont", FONT_Shout );
	CFG->writeEntry( "WhisperFont", FONT_Whisper );
	CFG->writeEntry( "NotificationFont", FONT_Notification );
}
///////////////////////////////////////
//
//	resource::buildStyle
//
///////////////////////////////////////
void resource::buildStyle( void )
{
	/* Configure SSI_Default */
	SSI_Default->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_Default->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_Default->setFontFamily( FONT_Standard.family() );
	SSI_Default->setFontSize( FONT_Standard.pointSize() );
	SSI_Default->setFontUnderline( FONT_Standard.underline() );
	SSI_Default->setFontItalic( FONT_Standard.italic() );
	SSI_Default->setFontWeight( FONT_Standard.weight() );
	SSI_Default->setColor( COLOR_Standard );
	/* Configure SSI_PrivateTell */
	SSI_PrivateTell->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_PrivateTell->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_PrivateTell->setFontFamily( FONT_PrivateTell.family() );
	SSI_PrivateTell->setFontSize( FONT_PrivateTell.pointSize() );
	SSI_PrivateTell->setFontUnderline( FONT_PrivateTell.underline() );
	SSI_PrivateTell->setFontItalic( FONT_PrivateTell.italic() );
	SSI_PrivateTell->setFontWeight( FONT_PrivateTell.weight() );
	SSI_PrivateTell->setColor( COLOR_PrivateTell );
	/* Configure SSI_ChannelTell */
	SSI_ChannelTell->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_ChannelTell->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_ChannelTell->setFontFamily( FONT_ChannelTell.family() );
	SSI_ChannelTell->setFontSize( FONT_ChannelTell.pointSize() );
	SSI_ChannelTell->setFontUnderline( FONT_ChannelTell.underline() );
	SSI_ChannelTell->setFontItalic( FONT_ChannelTell.italic() );
	SSI_ChannelTell->setFontWeight( FONT_ChannelTell.weight() );
	SSI_ChannelTell->setColor( COLOR_ChannelTell );
	/* Configure SSI_Shout */
	SSI_Shout->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_Shout->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_Shout->setFontFamily( FONT_Shout.family() );
	SSI_Shout->setFontSize( FONT_Shout.pointSize() );
	SSI_Shout->setFontUnderline( FONT_Shout.underline() );
	SSI_Shout->setFontItalic( FONT_Shout.italic() );
	SSI_Shout->setFontWeight( FONT_Shout.weight() );
	SSI_Shout->setColor( COLOR_Shout );
	/* Configure SSI_Whisper */
	SSI_Whisper->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_Whisper->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_Whisper->setFontFamily( FONT_Whisper.family() );
	SSI_Whisper->setFontSize( FONT_Whisper.pointSize() );
	SSI_Whisper->setFontUnderline( FONT_Whisper.underline() );
	SSI_Whisper->setFontItalic( FONT_Whisper.italic() );
	SSI_Whisper->setFontWeight( FONT_Whisper.weight() );
	SSI_Whisper->setColor( COLOR_Whisper );
	/* Configure SSI_Notification */
	SSI_Notification->setDisplayMode( QStyleSheetItem::DisplayBlock );
	SSI_Notification->setWhiteSpaceMode( QStyleSheetItem::WhiteSpacePre );
	SSI_Notification->setFontFamily( FONT_Notification.family() );
	SSI_Notification->setFontSize( FONT_Notification.pointSize() );
	SSI_Notification->setFontUnderline( FONT_Notification.underline() );
	SSI_Notification->setFontItalic( FONT_Notification.italic() );
	SSI_Notification->setFontWeight( FONT_Notification.weight() );
	SSI_Notification->setColor( COLOR_Notification );
}
///////////////////////////////////////
//
//	resource::themeURL
//
///////////////////////////////////////
QString resource::themeURL( const QString theme )
{
	kdDebug() << "resource::themeUrl" << endl;
	QString fullURL;
        kdDebug() << "Full url: " << theme << endl;
        fullURL = themeDir() + theme   + "/" ;
        kdDebug() << "themeURL " << fullURL << endl;
        return fullURL;
        
// 	fullURL = "tar:" + GlobalDataDir + "themes/" + theme;
// //	if( !KIO::NetAccess::exists( fullURL ) )
// //	{
//    	fullURL = "tar:" + QDir::currentDirPath() + "../media/" + theme;
// //   	if( !KIO::NetAccess::exists( fullURL ) )
//    	//{
// 	   	fullURL = QDir::homeDirPath() + "/.knights/" + theme;
//                 kdDebug() << "ThemeURL:: " << fullURL << endl;
// // 	   	if( !KIO::NetAccess::exists( fullURL ) )
// // 	   	{
// // 	   		kdWarning() << "The theme " << theme << " does not exist in any valid path." << endl;
// // 	   		return QString::null;
// // 	   	}
// //    	}
// // 	}
// 	//fullURL += "/";
// 	return fullURL;
}

#undef CFG


