

#include <math.h>

#include "settingsbase.h"
#include "ThemeSelectionDialog.h"
#include "ThemeBoardSelectionDialog.h"
#include "EngineSelectionDialog.h"
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include "definitions.h"
#include <kdebug.h>
#include <qpe/qpeapplication.h>
#include <qpe/config.h>
class QCheckBox;
settingsBase::settingsBase(QWidget* parent,  const char* name, resource *Rsrc, bool modal, WFlags fl )
    : settingsDialog( parent, name, modal, fl )
{
qDebug("settingsBase::settingsBase");
Resource = Rsrc;

Resource->ConfigRead();

//displayWidget->qualityCheck->setChecked( Resource->OPTION_High_Quality );
reverseCheck->setChecked( Resource->OPTION_Board_Orientation );
previewCheck->setChecked(Resource->OPTION_Auto_Preview);
showCoordsCheck->setChecked( Resource->OPTION_Show_Coord );
showLastMoveCheck->setChecked ( Resource->OPTION_Show_Last_Move );
// themeSizeSpin->setMinValue(2);
// themeSizeSpin->setMaxValue(14);
// themeSizeSpin->setLineStep(2);
// themeSizeSpin->setValue(floor( Resource->ThemeSize - IMAGE_MIN ) / 2 );

userNameEdit->setText( Resource->Local_Player );

if (Resource->PromptForSaving == "Yes")
  closeCombo->setCurrentItem(0);
else if (Resource->PromptForSaving == "No")
  closeCombo->setCurrentItem(1);
else
  closeCombo->setCurrentItem(2);

if( Resource->OPTION_On_Init == 0)
  startUpCombo->setCurrentItem(0);
else if( Resource->OPTION_On_Init == MENU_VS_PC)
  startUpCombo->setCurrentItem(1);
 
  
  

autoCallFlagCheck->setChecked(( Resource->OPTION_Auto_Call_Flag ));
autoPromoteQueenCheck->setChecked( Resource->OPTION_Auto_Queen );
QString current = Resource->CurrentChessmen.mid(2);
if (!Resource->CurrentChessmen.isEmpty()) {
  if ((Resource->CurrentChessmen).length()>=3) {
  for (int i=0;i<chessmenWidget->list->count();i++)
    {
     // kdDebug() << ((Resource->CurrentChessmen).mid(2)) << endl;
      QString s = chessmenWidget->list->item(i)->text();
      if (chessmenWidget->list->item(i)->text()==current) {
        chessmenWidget->list->setSelected(i,true);
        break;
      }
    }
 }
} 

 if ((Resource->CurrentBoard).length()>=3) {
 for (int i=0;i<boardWidget->list->count();i++)
 {
 kdDebug() << ((Resource->CurrentBoard).mid(2)) << endl;
 if (boardWidget->list->item(i)->text()==((Resource->CurrentBoard).mid(2))) {
    boardWidget->list->setSelected(i,true);
    break;
 }
 }
 }

for (int i=0;i<engineWidget->list->count();i++)
{
kdDebug() << ((Resource->currentEngineName)) << endl;
if (engineWidget->list->item(i)->text()==(Resource->currentEngineName)) {
   engineWidget->list->setSelected(i,true);
   break;
}
}
 


}

settingsBase::~settingsBase()
{
}


void settingsBase::accept()
{
//write settings here.
//engine settings
QString engine=engineWidget->currentEngine();
//Config config(QPEApplication::qpeDir()+"/chess/engines/"+engine+"/capablities",Config::File);
Resource->setCurrentEngineName(engine);
Resource->ReadEngines();
QString theme=chessmenWidget->currentTheme();
if (!theme.isEmpty())
  Resource->setCurrentChessmen(theme);
theme=boardWidget->currentBoardTheme();
if (!theme.isEmpty())
  Resource->setCurrentBoard(theme);

  
  
Resource->OPTION_Show_Last_Move = showLastMoveCheck->isChecked();
Resource->OPTION_Auto_Preview = previewCheck->isChecked();
Resource->OPTION_Board_Orientation= reverseCheck->isChecked();
Resource->OPTION_Show_Coord  = showCoordsCheck->isChecked();
Resource->OPTION_Show_Last_Move = showLastMoveCheck->isChecked(); 
  

Resource->OPTION_Auto_Call_Flag  = autoCallFlagCheck->isChecked();
Resource->OPTION_Auto_Queen = autoPromoteQueenCheck->isChecked();

if (closeCombo->currentItem() == 0)
  Resource->PromptForSaving="Yes";
else if (closeCombo->currentItem() == 1)
  Resource->PromptForSaving="No";
else if (closeCombo->currentItem() == 2)
  Resource->PromptForSaving="Ask";

if (startUpCombo->currentItem() == 0)
  Resource->OPTION_On_Init=1;
else if (startUpCombo->currentItem() == 1)
  Resource->OPTION_On_Init=MENU_VS_PC;

Resource->Local_Player=userNameEdit->text();
  
emit themeChanged(chessmenWidget->currentTheme());
emit themeBoardChanged(boardWidget->currentBoardTheme());

emit redrawBoard();




Resource->ConfigWrite();

done( Accepted );
}
