/***************************************************************************
                          thinbuttons.cpp  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001, 2002 by Troy Corbin Jr.
    email                : tcorbin@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "thinbuttons.h"
#include <qstyle.h>

thinbuttons::thinbuttons(QWidget *parent, const char *name, resource *Rsrc ) : QFrame(parent,name)
{
	Resource = Rsrc;
	seed = 0;
	setFixedSize( 8, 8 );
//	matchMenu = new KPopupMenu( this );

//	matchMenu->insertItem( i18n("menuitem"), this, SLOT( menuFunct(int) ), 0, MENU_CENSOR );
}
thinbuttons::~thinbuttons()
{
}
///////////////////////////////////////
//
//	thinbuttons::childEvent
//
///////////////////////////////////////
void thinbuttons::childEvent( QChildEvent * cev )
{
	Buttons *newBut;

	if( cev->inserted() )
	{
		newBut = new Buttons;
		newBut->button = (QButton*)cev->child();
		newBut->ID = seed++;
		buttons.append( newBut );
		connect( cev->child(), SIGNAL( clicked() ), this, SLOT( buttonClicked() ) );
	}
	if( cev->removed() )
		remove( (QButton*)cev->child() );
}
///////////////////////////////////////
//
//	thinbuttons::setButton
//
///////////////////////////////////////
void thinbuttons::setButton( int id )
{
	Buttons *currentBut;
	unsigned int Index;

	for( Index = 0; Index < buttons.count(); Index++ )
	{
		currentBut = buttons.at( Index );
		if( currentBut->ID == id )
		{
			currentBut->button->setDown( TRUE );
			if( currentBut->button->isToggleButton() )
				if( currentBut->button->state() != QButton::On )
					currentBut->button->toggle();
		}
		else
		{
			currentBut->button->setDown( FALSE );
			if( currentBut->button->isToggleButton() )
				if( currentBut->button->state() == QButton::On )
					currentBut->button->toggle();
		}
	}	
}
///////////////////////////////////////
//
//	thinbuttons::find
//
///////////////////////////////////////
QButton* thinbuttons::find( int id )
{
	unsigned int tmp;

	for( tmp = 0; tmp < buttons.count(); tmp++ )
		if( buttons.at( tmp )->ID == id )
			return buttons.at( tmp )->button;
	return NULL;
}
///////////////////////////////////////
//
//	thinbuttons::id
//
///////////////////////////////////////
int thinbuttons::id( QButton* button )
{
	unsigned int tmp;

	for( tmp = 0; tmp < buttons.count(); tmp++ )
		if( buttons.at( tmp )->button == button )
			return buttons.at( tmp )->ID;
	return -1;
}
///////////////////////////////////////
//
//	thinbuttons::remove
//
///////////////////////////////////////
void thinbuttons::remove( QButton* button )
{
	unsigned int tmp;

	for( tmp = 0; tmp < buttons.count(); tmp++ )
		if( buttons.at( tmp )->button == button )
		{
			disconnect( buttons.at( tmp )->button, SIGNAL( clicked() ), this, SLOT( buttonClicked() ) );
			buttons.remove( tmp );
		}
}
///////////////////////////////////////
//
//	thinbuttons::buttonClicked
//
///////////////////////////////////////
void thinbuttons::buttonClicked( void )
{
	const QObject *incomming;
	int Clicked;
	unsigned int tmp;

	incomming = sender();
	for( tmp = 0; tmp < buttons.count(); tmp++ )
		if( buttons.at( tmp )->button == ( const QButton* )incomming )
		{
			Clicked = buttons.at( tmp )->ID;
			if( Clicked == Null ) return;
			setButton( Clicked );
			emit clicked( Clicked );
		}
}
///////////////////////////////////////
//
//	thinbuttons::resize
//
///////////////////////////////////////
void thinbuttons::resize( const int Width )
{
	Buttons *button;
//	QStyle& Style = QApplication::style();
	int margin = 5;
	int newWidth;
	unsigned int Index;

//	margin = Style.defaultFrameWidth();
	if( buttons.count() != 0 ) newWidth = ( Width / buttons.count() ) - ( margin * 2 );
	else newWidth = 0;
	setFixedSize( Width, Resource->Widget_Height + margin );
	for( Index = 0; Index < buttons.count(); Index++ )
	{
		button = buttons.at( Index );
		button->button->setFixedSize( newWidth, Resource->Widget_Height );
		button->button->move( ( Index * ( newWidth + ( margin * 2 ) ) ) + margin , margin );
	}
}
///////////////////////////////////////
//
//	thinbuttons::menuFunct
//
///////////////////////////////////////
void thinbuttons::menuFunct( int funct )
{
	switch( funct )
	{
		case MENU_SELECT_ALL:
			break;
		default:
			break;
	}
}
